{++

g l u . p a s

Translation of glu.h, converted by htrans 0.3.3
Copyright (c) 1997 Alexander Staubo, all rights reserved.

[Generated on 25-08-1997 at 01:55]

--}

unit Glu;

{$ALIGN ON}
{$MINENUMSIZE 4}

interface

uses
  Windows, SysUtils, Gl;

type
  PPointer = ^Pointer;
  USHORT = Word;

  TCallback = procedure; pascal;

(*
** Copyright 1991-1993, Silicon Graphics, Inc.
** All Rights Reserved.
** 
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
** 
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*)

{***********************************************************}

{ Extensions }

const
  GLU_EXT_object_space_tess = 1;
  GLU_EXT_nurbs_tessellator = 1;
  
{ Boolean }
  
  GLU_FALSE = 0;
  GLU_TRUE = 1;
  
{ Version }
  
  GLU_VERSION_1_1 = 1;
  GLU_VERSION_1_2 = 1;

{ StringName }
  
  GLU_VERSION = 100800;
  GLU_EXTENSIONS = 100801;
  
{ ErrorCode }
  
  GLU_INVALID_ENUM = 100900;
  GLU_INVALID_VALUE = 100901;
  GLU_OUT_OF_MEMORY = 100902;
  GLU_INCOMPATIBLE_GL_VERSION = 100903;
  GLU_INVALID_OPERATION = 100904;
  
{ NurbsDisplay }
  
{      GLU_FILL }
  
  GLU_OUTLINE_POLYGON = 100240;
  GLU_OUTLINE_PATCH = 100241;
  
{ NurbsCallback }
  
  GLU_ERROR = 100103;
  
{ NurbsError }
  
  GLU_NURBS_ERROR1 = 100251;
  GLU_NURBS_ERROR2 = 100252;
  GLU_NURBS_ERROR3 = 100253;
  GLU_NURBS_ERROR4 = 100254;
  GLU_NURBS_ERROR5 = 100255;
  GLU_NURBS_ERROR6 = 100256;
  GLU_NURBS_ERROR7 = 100257;
  GLU_NURBS_ERROR8 = 100258;
  GLU_NURBS_ERROR9 = 100259;
  GLU_NURBS_ERROR10 = 100260;
  GLU_NURBS_ERROR11 = 100261;
  GLU_NURBS_ERROR12 = 100262;
  GLU_NURBS_ERROR13 = 100263;
  GLU_NURBS_ERROR14 = 100264;
  GLU_NURBS_ERROR15 = 100265;
  GLU_NURBS_ERROR16 = 100266;
  GLU_NURBS_ERROR17 = 100267;
  GLU_NURBS_ERROR18 = 100268;
  GLU_NURBS_ERROR19 = 100269;
  GLU_NURBS_ERROR20 = 100270;
  GLU_NURBS_ERROR21 = 100271;
  GLU_NURBS_ERROR22 = 100272;
  GLU_NURBS_ERROR23 = 100273;
  GLU_NURBS_ERROR24 = 100274;
  GLU_NURBS_ERROR25 = 100275;
  GLU_NURBS_ERROR26 = 100276;
  GLU_NURBS_ERROR27 = 100277;
  GLU_NURBS_ERROR28 = 100278;
  GLU_NURBS_ERROR29 = 100279;
  GLU_NURBS_ERROR30 = 100280;
  GLU_NURBS_ERROR31 = 100281;
  GLU_NURBS_ERROR32 = 100282;
  GLU_NURBS_ERROR33 = 100283;
  GLU_NURBS_ERROR34 = 100284;
  GLU_NURBS_ERROR35 = 100285;
  GLU_NURBS_ERROR36 = 100286;
  GLU_NURBS_ERROR37 = 100287;
  
{ NurbsProperty }
  
  GLU_AUTO_LOAD_MATRIX = 100200;
  GLU_CULLING = 100201;
  GLU_SAMPLING_TOLERANCE = 100203;
  GLU_DISPLAY_MODE = 100204;
  GLU_PARAMETRIC_TOLERANCE = 100202;
  GLU_SAMPLING_METHOD = 100205;
  GLU_U_STEP = 100206;
  GLU_V_STEP = 100207;
  
{ NurbsSampling }
  
  GLU_OBJECT_PARAMETRIC_ERROR_EXT = 100208;
  GLU_OBJECT_PATH_LENGTH_EXT = 100209;
  GLU_PATH_LENGTH = 100215;
  GLU_PARAMETRIC_ERROR = 100216;
  GLU_DOMAIN_DISTANCE = 100217;
  
{ NurbsTrim }
  
  GLU_MAP1_TRIM_2 = 100210;
  GLU_MAP1_TRIM_3 = 100211;
  
{ QuadricDrawStyle }
  
  GLU_POINT = 100010;
  GLU_LINE = 100011;
  GLU_FILL = 100012;
  GLU_SILHOUETTE = 100013;
  
{ QuadricCallback }
  
{      GLU_ERROR }
  
{ QuadricNormal }
  
  GLU_SMOOTH = 100000;
  GLU_FLAT = 100001;
  GLU_NONE = 100002;
  
{ QuadricOrientation }
  
  GLU_OUTSIDE = 100020;
  GLU_INSIDE = 100021;
  
{ TessCallback }
  
  GLU_TESS_BEGIN = 100100;
  GLU_BEGIN = 100100;
  GLU_TESS_VERTEX = 100101;
  GLU_VERTEX = 100101;
  GLU_TESS_END = 100102;
  GLU_END = 100102;
  GLU_TESS_ERROR = 100103;
  GLU_TESS_EDGE_FLAG = 100104;
  GLU_EDGE_FLAG = 100104;
  GLU_TESS_COMBINE = 100105;
  GLU_TESS_BEGIN_DATA = 100106;
  GLU_TESS_VERTEX_DATA = 100107;
  GLU_TESS_END_DATA = 100108;
  GLU_TESS_ERROR_DATA = 100109;
  GLU_TESS_EDGE_FLAG_DATA = 100110;
  GLU_TESS_COMBINE_DATA = 100111;
  GLU_NURBS_MODE_EXT = 100160;
  GLU_NURBS_TESSELLATOR_EXT = 100161;
  GLU_NURBS_RENDERER_EXT = 100162;
  GLU_NURBS_BEGIN_EXT = 100164;
  GLU_NURBS_VERTEX_EXT = 100165;
  GLU_NURBS_NORMAL_EXT = 100166;
  GLU_NURBS_COLOR_EXT = 100167;
  GLU_NURBS_TEX_COORD_EXT = 100168;
  GLU_NURBS_END_EXT = 100169;
  GLU_NURBS_BEGIN_DATA_EXT = 100170;
  GLU_NURBS_VERTEX_DATA_EXT = 100171;
  GLU_NURBS_NORMAL_DATA_EXT = 100172;
  GLU_NURBS_COLOR_DATA_EXT = 100173;
  GLU_NURBS_TEX_COORD_DATA_EXT = 100174;
  GLU_NURBS_END_DATA_EXT = 100175;
  
{ TessContour }
  
  GLU_CW = 100120;
  GLU_CCW = 100121;
  GLU_INTERIOR = 100122;
  GLU_EXTERIOR = 100123;
  GLU_UNKNOWN = 100124;
  
{ TessProperty }
  
  GLU_TESS_WINDING_RULE = 100140;
  GLU_TESS_BOUNDARY_ONLY = 100141;
  GLU_TESS_TOLERANCE = 100142;
  
{ TessError }
  
  GLU_TESS_ERROR1 = 100151;
  GLU_TESS_ERROR2 = 100152;
  GLU_TESS_ERROR3 = 100153;
  GLU_TESS_ERROR4 = 100154;
  GLU_TESS_ERROR5 = 100155;
  GLU_TESS_ERROR6 = 100156;
  GLU_TESS_ERROR7 = 100157;
  GLU_TESS_ERROR8 = 100158;
  GLU_TESS_MISSING_BEGIN_POLYGON = 100151;
  GLU_TESS_MISSING_BEGIN_CONTOUR = 100152;
  GLU_TESS_MISSING_END_POLYGON = 100153;
  GLU_TESS_MISSING_END_CONTOUR = 100154;
  GLU_TESS_COORD_TOO_LARGE = 100155;
  GLU_TESS_NEED_COMBINE_CALLBACK = 100156;
  
{ TessWinding }
  
  GLU_TESS_WINDING_ODD = 100130;
  GLU_TESS_WINDING_NONZERO = 100131;
  GLU_TESS_WINDING_POSITIVE = 100132;
  GLU_TESS_WINDING_NEGATIVE = 100133;
  GLU_TESS_WINDING_ABS_GEQ_TWO = 100134;

{***********************************************************}

type
  GLUnurbs = record end;
  PGLUnurbs = ^GLUnurbs;

  GLUquadric = record end;
  PGLUquadric = ^GLUquadric;

  GLUtesselator = record end;
  PGLUtesselator = ^GLUtesselator;

  GLUnurbsObj = GLUnurbs;
  GLUquadricObj = GLUquadric;
  GLUtesselatorObj = GLUtesselator;
  GLUtriangulatorObj = GLUtesselator;

const
  GLU_TESS_MAX_COORD = 1.0e150;

type
  TgluBeginCurveProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluBeginPolygonProc = procedure (tess : PGLUtesselator); stdcall;

  TgluBeginSurfaceProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluBeginTrimProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluBuild1DMipmapsProc = function (target : GLenum; component : GLint;
    width : GLsizei; format : GLenum; _type : GLenum;
    data : Pointer) : GLint; stdcall;

  TgluBuild2DMipmapsProc = function (target : GLenum; component : GLint;
    width : GLsizei; height : GLsizei; format : GLenum; _type : GLenum;
    data : Pointer) : GLint; stdcall;

  TgluCylinderProc = procedure (quad : PGLUquadric;
    base : GLdouble; top : GLdouble; height : GLdouble; slices : GLint;
    stacks : GLint); stdcall;

  TgluDeleteNurbsRendererProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluDeleteNurbsTessellatorEXTProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluDeleteQuadricProc = procedure (quad : PGLUquadric); stdcall;

  TgluDeleteTessProc = procedure (tess : PGLUtesselator); stdcall;

  TgluDiskProc = procedure (quad : PGLUquadric; inner : GLdouble;
    outer : GLdouble; slices : GLint; loops : GLint); stdcall;

  TgluEndCurveProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluEndPolygonProc = procedure (tess : PGLUtesselator); stdcall;

  TgluEndSurfaceProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluEndTrimProc = procedure (nurb : PGLUnurbs); stdcall;

  TgluErrorStringProc = function (error : GLenum) : PGLubyte; stdcall;

  TgluGetNurbsPropertyProc = procedure (nurb : PGLUnurbs; _property : GLenum;
    data : PGLfloat); stdcall;

  TgluGetStringProc = function (name : GLenum) : PGLubyte; stdcall;

  TgluGetTessPropertyProc = procedure (tess : PGLUtesselator; which : GLenum;
    data : PGLdouble); stdcall;

  TgluLoadSamplingMatricesProc = procedure (nurb : PGLUnurbs;
    {!! const } model : PGLfloat; {!! const } perspective : PGLfloat;
    {!! const } view : PGLint); stdcall;

  TgluLookAtProc = procedure (eyeX : GLdouble; eyeY : GLdouble;
    eyeZ : GLdouble; centerX : GLdouble; centerY : GLdouble;
    centerZ : GLdouble; upX : GLdouble; upY : GLdouble;
    upZ : GLdouble); stdcall;

  TgluNewNurbsRendererProc = function : PGLUnurbs; stdcall;

  TgluNewNurbsTessellatorEXTProc = function : PGLUnurbs; stdcall;

  TgluNewQuadricProc = function : PGLUquadric; stdcall;

  TgluNewTessProc = function : PGLUtesselator; stdcall;

  TgluNextContourProc = procedure (tess : PGLUtesselator;
    _type : GLenum); stdcall;

  TgluNurbsCallbackProc = procedure (nurb : PGLUnurbs; which : GLenum;
    CallBackFunc : TCallback); stdcall;

  TgluNurbsCallbackDataEXTProc = procedure (nurb : PGLUnurbs;
    userData : PGLvoid); stdcall;

  TgluNurbsCurveProc = procedure (nurb : PGLUnurbs; knotCount : GLint;
    knots : PGLfloat; stride : GLint; control : PGLfloat; order : GLint;
    _type : GLenum); stdcall;

  TgluNurbsPropertyProc = procedure (nurb : PGLUnurbs; _property : GLenum;
    value : GLfloat); stdcall;

  TgluNurbsSurfaceProc = procedure (nurb : PGLUnurbs; sKnotCount : GLint;
    sKnots : PGLfloat; tKnotCount : GLint; tKnots : PGLfloat; sStride : GLint;
    tStride : GLint; control : PGLfloat; sOrder : GLint; tOrder : GLint;
    _type : GLenum); stdcall;

  TgluOrtho2DProc = procedure (left : GLdouble; right : GLdouble;
    bottom : GLdouble; top : GLdouble); stdcall;

  TgluPartialDiskProc = procedure (quad : PGLUquadric; inner : GLdouble;
    outer : GLdouble; slices : GLint; loops : GLint; start : GLdouble;
    sweep : GLdouble); stdcall;

  TgluPerspectiveProc = procedure (fovy : GLdouble; aspect : GLdouble;
    zNear : GLdouble; zFar : GLdouble); stdcall;

  TgluPickMatrixProc = procedure (x : GLdouble; y : GLdouble; delX : GLdouble;
    delY : GLdouble; viewport : PGLint); stdcall;

  TgluProjectProc = function (objX : GLdouble; objY : GLdouble;
    objZ : GLdouble; {!! const } model : PGLdouble;
    {!! const } proj : PGLdouble; {!! const } view : PGLint; winX : PGLdouble;
    winY : PGLdouble; winZ : PGLdouble) : GLint; stdcall;

  TgluPwlCurveProc = procedure (nurb : PGLUnurbs; count : GLint;
    data : PGLfloat; stride : GLint; _type : GLenum); stdcall;

  TgluQuadricCallbackProc = procedure (quad : PGLUquadric; which : GLenum;
    CallBackFunc : TCallback); stdcall;

  TgluQuadricDrawStyleProc = procedure (quad : PGLUquadric;
    draw : GLenum); stdcall;

  TgluQuadricNormalsProc = procedure (quad : PGLUquadric;
    normal : GLenum); stdcall;

  TgluQuadricOrientationProc = procedure (quad : PGLUquadric;
    orientation : GLenum); stdcall;

  TgluQuadricTextureProc = procedure (quad : PGLUquadric;
    texture : GLboolean); stdcall;

  TgluScaleImageProc = function (format : GLenum; wIn : GLsizei; hIn : GLsizei;
    typeIn : GLenum; {!! const } dataIn : Pointer; wOut : GLsizei;
    hOut : GLsizei; typeOut : GLenum; dataOut : PGLvoid) : GLint; stdcall;

  TgluSphereProc = procedure (quad : PGLUquadric; radius : GLdouble;
    slices : GLint; stacks : GLint); stdcall;

  TgluTessBeginContourProc = procedure (tess : PGLUtesselator); stdcall;

  TgluTessBeginPolygonProc = procedure (tess : PGLUtesselator;
    data : PGLvoid); stdcall;

  TgluTessCallbackProc = procedure (tess : PGLUtesselator; which : GLenum;
    CallBackFunc : TCallback); stdcall;

  TgluTessEndContourProc = procedure (tess : PGLUtesselator); stdcall;

  TgluTessEndPolygonProc = procedure (tess : PGLUtesselator); stdcall;

  TgluTessNormalProc = procedure (tess : PGLUtesselator; valueX : GLdouble;
    valueY : GLdouble; valueZ : GLdouble); stdcall;

  TgluTessPropertyProc = procedure (tess : PGLUtesselator; which : GLenum;
    data : GLdouble); stdcall;

  TgluTessVertexProc = procedure (tess : PGLUtesselator; location : PGLdouble;
    data : PGLvoid); stdcall;

  TgluUnProjectProc = function (winX : GLdouble; winY : GLdouble;
    winZ : GLdouble; {!! const } model : PGLdouble;
    {!! const } proj : PGLdouble; {!! const } view : PGLint; objX : PGLdouble;
    objY : PGLdouble; objZ : PGLdouble) : GLint; stdcall;

{!! Function variables }

var
  gluBeginCurve : TgluBeginCurveProc;
  gluBeginPolygon : TgluBeginPolygonProc;
  gluBeginSurface : TgluBeginSurfaceProc;
  gluBeginTrim : TgluBeginTrimProc;
  gluBuild1DMipmaps : TgluBuild1DMipmapsProc;
  gluBuild2DMipmaps : TgluBuild2DMipmapsProc;
  gluCylinder : TgluCylinderProc;
  gluDeleteNurbsRenderer : TgluDeleteNurbsRendererProc;
  gluDeleteNurbsTessellatorEXT : TgluDeleteNurbsTessellatorEXTProc;
  gluDeleteQuadric : TgluDeleteQuadricProc;
  gluDeleteTess : TgluDeleteTessProc;
  gluDisk : TgluDiskProc;
  gluEndCurve : TgluEndCurveProc;
  gluEndPolygon : TgluEndPolygonProc;
  gluEndSurface : TgluEndSurfaceProc;
  gluEndTrim : TgluEndTrimProc;
  gluErrorString : TgluErrorStringProc;
  gluGetNurbsProperty : TgluGetNurbsPropertyProc;
  gluGetString : TgluGetStringProc;
  gluGetTessProperty : TgluGetTessPropertyProc;
  gluLoadSamplingMatrices : TgluLoadSamplingMatricesProc;
  gluLookAt : TgluLookAtProc;
  gluNewNurbsRenderer : TgluNewNurbsRendererProc;
  gluNewNurbsTessellatorEXT : TgluNewNurbsTessellatorEXTProc;
  gluNewQuadric : TgluNewQuadricProc;
  gluNewTess : TgluNewTessProc;
  gluNextContour : TgluNextContourProc;
  gluNurbsCallback : TgluNurbsCallbackProc;
  gluNurbsCallbackDataEXT : TgluNurbsCallbackDataEXTProc;
  gluNurbsCurve : TgluNurbsCurveProc;
  gluNurbsProperty : TgluNurbsPropertyProc;
  gluNurbsSurface : TgluNurbsSurfaceProc;
  gluOrtho2D : TgluOrtho2DProc;
  gluPartialDisk : TgluPartialDiskProc;
  gluPerspective : TgluPerspectiveProc;
  gluPickMatrix : TgluPickMatrixProc;
  gluProject : TgluProjectProc;
  gluPwlCurve : TgluPwlCurveProc;
  gluQuadricCallback : TgluQuadricCallbackProc;
  gluQuadricDrawStyle : TgluQuadricDrawStyleProc;
  gluQuadricNormals : TgluQuadricNormalsProc;
  gluQuadricOrientation : TgluQuadricOrientationProc;
  gluQuadricTexture : TgluQuadricTextureProc;
  gluScaleImage : TgluScaleImageProc;
  gluSphere : TgluSphereProc;
  gluTessBeginContour : TgluTessBeginContourProc;
  gluTessBeginPolygon : TgluTessBeginPolygonProc;
  gluTessCallback : TgluTessCallbackProc;
  gluTessEndContour : TgluTessEndContourProc;
  gluTessEndPolygon : TgluTessEndPolygonProc;
  gluTessNormal : TgluTessNormalProc;
  gluTessProperty : TgluTessPropertyProc;
  gluTessVertex : TgluTessVertexProc;
  gluUnProject : TgluUnProjectProc;

{!! Unit initialization }

procedure GluInitialize;

procedure GluUninitialize;

procedure GluInitializeFromLibrary (const DllName : string);

implementation

{ Private stuff }

var
  GluHandle : HINST;

procedure InitError (ErrorCode : Integer);
begin
  raise Exception.CreateFmt('Error %d initializing OpenGL: %s', [ErrorCode,
    SysErrorMessage(ErrorCode)]);
end;

procedure GluLoadProcs (Handle : HINST);
begin
  @gluBeginCurve:=GetProcAddress(Handle, 'gluBeginCurve');
  @gluBeginPolygon:=GetProcAddress(Handle, 'gluBeginPolygon');
  @gluBeginSurface:=GetProcAddress(Handle, 'gluBeginSurface');
  @gluBeginTrim:=GetProcAddress(Handle, 'gluBeginTrim');
  @gluBuild1DMipmaps:=GetProcAddress(Handle, 'gluBuild1DMipmaps');
  @gluBuild2DMipmaps:=GetProcAddress(Handle, 'gluBuild2DMipmaps');
  @gluCylinder:=GetProcAddress(Handle, 'gluCylinder');
  @gluDeleteNurbsRenderer:=GetProcAddress(Handle, 'gluDeleteNurbsRenderer');
  @gluDeleteNurbsTessellatorEXT:=GetProcAddress(Handle,
    'gluDeleteNurbsTessellatorEXT');
  @gluDeleteQuadric:=GetProcAddress(Handle, 'gluDeleteQuadric');
  @gluDeleteTess:=GetProcAddress(Handle, 'gluDeleteTess');
  @gluDisk:=GetProcAddress(Handle, 'gluDisk');
  @gluEndCurve:=GetProcAddress(Handle, 'gluEndCurve');
  @gluEndPolygon:=GetProcAddress(Handle, 'gluEndPolygon');
  @gluEndSurface:=GetProcAddress(Handle, 'gluEndSurface');
  @gluEndTrim:=GetProcAddress(Handle, 'gluEndTrim');
  @gluErrorString:=GetProcAddress(Handle, 'gluErrorString');
  @gluGetNurbsProperty:=GetProcAddress(Handle, 'gluGetNurbsProperty');
  @gluGetString:=GetProcAddress(Handle, 'gluGetString');
  @gluGetTessProperty:=GetProcAddress(Handle, 'gluGetTessProperty');
  @gluLoadSamplingMatrices:=GetProcAddress(Handle, 'gluLoadSamplingMatrices');
  @gluLookAt:=GetProcAddress(Handle, 'gluLookAt');
  @gluNewNurbsRenderer:=GetProcAddress(Handle, 'gluNewNurbsRenderer');
  @gluNewNurbsTessellatorEXT:=GetProcAddress(Handle,
    'gluNewNurbsTessellatorEXT');
  @gluNewQuadric:=GetProcAddress(Handle, 'gluNewQuadric');
  @gluNewTess:=GetProcAddress(Handle, 'gluNewTess');
  @gluNextContour:=GetProcAddress(Handle, 'gluNextContour');
  @gluNurbsCallback:=GetProcAddress(Handle, 'gluNurbsCallback');
  @gluNurbsCallbackDataEXT:=GetProcAddress(Handle, 'gluNurbsCallbackDataEXT');
  @gluNurbsCurve:=GetProcAddress(Handle, 'gluNurbsCurve');
  @gluNurbsProperty:=GetProcAddress(Handle, 'gluNurbsProperty');
  @gluNurbsSurface:=GetProcAddress(Handle, 'gluNurbsSurface');
  @gluOrtho2D:=GetProcAddress(Handle, 'gluOrtho2D');
  @gluPartialDisk:=GetProcAddress(Handle, 'gluPartialDisk');
  @gluPerspective:=GetProcAddress(Handle, 'gluPerspective');
  @gluPickMatrix:=GetProcAddress(Handle, 'gluPickMatrix');
  @gluProject:=GetProcAddress(Handle, 'gluProject');
  @gluPwlCurve:=GetProcAddress(Handle, 'gluPwlCurve');
  @gluQuadricCallback:=GetProcAddress(Handle, 'gluQuadricCallback');
  @gluQuadricDrawStyle:=GetProcAddress(Handle, 'gluQuadricDrawStyle');
  @gluQuadricNormals:=GetProcAddress(Handle, 'gluQuadricNormals');
  @gluQuadricOrientation:=GetProcAddress(Handle, 'gluQuadricOrientation');
  @gluQuadricTexture:=GetProcAddress(Handle, 'gluQuadricTexture');
  @gluScaleImage:=GetProcAddress(Handle, 'gluScaleImage');
  @gluSphere:=GetProcAddress(Handle, 'gluSphere');
  @gluTessBeginContour:=GetProcAddress(Handle, 'gluTessBeginContour');
  @gluTessBeginPolygon:=GetProcAddress(Handle, 'gluTessBeginPolygon');
  @gluTessCallback:=GetProcAddress(Handle, 'gluTessCallback');
  @gluTessEndContour:=GetProcAddress(Handle, 'gluTessEndContour');
  @gluTessEndPolygon:=GetProcAddress(Handle, 'gluTessEndPolygon');
  @gluTessNormal:=GetProcAddress(Handle, 'gluTessNormal');
  @gluTessProperty:=GetProcAddress(Handle, 'gluTessProperty');
  @gluTessVertex:=GetProcAddress(Handle, 'gluTessVertex');
  @gluUnProject:=GetProcAddress(Handle, 'gluUnProject');
end;

{ Functions }

procedure GluInitialize;
var
  Handle : HINST;
begin
  GluUninitialize;
  Handle:=LoadLibrary('glu.dll');
  if Handle = 0 then
    begin
      Handle:=LoadLibrary('glu32.dll');
      if Handle = 0 then
        InitError(GetLastError);
    end;
  try
    GluLoadProcs(Handle);
  except
    FreeLibrary(Handle);
    raise;
  end;
  GluHandle:=Handle;
end;

procedure GluUninitialize;
begin
  if GluHandle <> 0 then
    begin
      FreeLibrary(GluHandle);
      GluHandle:=0;
    end;
end;

procedure GluInitializeFromLibrary (const DllName : string);
var
  Handle : HINST;
begin
  GluUninitialize;
  Handle:=LoadLibrary(PChar(DllName));
  if Handle = 0 then
    InitError(GetLastError);
  try
    GluLoadProcs(Handle);
  except
    FreeLibrary(Handle);
    raise;
  end;
  GluHandle:=Handle;
end;

{ Initialization }

initialization
  begin
  end;

finalization
  begin
    GluUninitialize;
  end;

end.

