{++

g l . p a s

Translation of gl.h, converted by htrans 0.3.3
Copyright (c) 1997 Alexander Staubo, all rights reserved.

[Generated on 25-08-1997 at 01:55]

--}

unit Gl;

{$ALIGN ON}
{$MINENUMSIZE 4}

interface

uses
  Windows, SysUtils;

(*
** Copyright 1992-1997 Silicon Graphics, Inc.
** All Rights Reserved.
**
** This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
** the contents of this file may not be disclosed to third parties, copied or
** duplicated in any form, in whole or in part, without the prior written
** permission of Silicon Graphics, Inc.
**
** RESTRICTED RIGHTS LEGEND:
** Use, duplication or disclosure by the Government is subject to restrictions
** as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
** and Computer Software clause at DFARS 252.227-7013, and/or in similar or
** successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
** rights reserved under the Copyright Laws of the United States.
*)

type
  GLenum = Integer;
  PGLenum = ^GLenum;

  GLboolean = Byte;
  PGLboolean = ^GLboolean;

  GLbitfield = Integer;
  PGLbitfield = ^GLbitfield;

  GLbyte = Char;
  PGLbyte = ^GLbyte;

  GLshort = Smallint;
  PGLshort = ^GLshort;

  GLint = Integer;
  PGLint = ^GLint;

  GLsizei = Integer;
  PGLsizei = ^GLsizei;

  GLubyte = Byte;
  PGLubyte = ^GLubyte;

  GLushort = Word;
  PGLushort = ^GLushort;

  GLuint = Integer;
  PGLuint = ^GLuint;

  GLfloat = Single;
  PGLfloat = ^GLfloat;

  GLclampf = Single;
  PGLclampf = ^GLclampf;

  GLdouble = Double;
  PGLdouble = ^GLdouble;

  GLclampd = Double;
  PGLclampd = ^GLclampd;

  PGLvoid = Pointer;
  PPGLvoid = ^PGLvoid;

{***********************************************************}

{ Extensions }

const
  GL_VERSION_1_1 = 1;
  GL_EXT_abgr = 1;
  GL_EXT_bgra = 1;
  GL_EXT_packed_pixels = 1;
  GL_EXT_paletted_texture = 1;
  GL_EXT_vertex_array = 1;
  GL_SGI_compiled_vertex_array = 1;
  GL_SGI_cull_vertex = 1;
  GL_SGI_index_array_formats = 1;
  GL_SGI_index_func = 1;
  GL_SGI_index_material = 1;
  GL_SGI_index_texture = 1;
  GL_WIN_swap_hint = 1;

{ AttribMask }

const
  GL_CURRENT_BIT = $00000001;
  GL_POINT_BIT = $00000002;
  GL_LINE_BIT = $00000004;
  GL_POLYGON_BIT = $00000008;
  GL_POLYGON_STIPPLE_BIT = $00000010;
  GL_PIXEL_MODE_BIT = $00000020;
  GL_LIGHTING_BIT = $00000040;
  GL_FOG_BIT = $00000080;
  GL_DEPTH_BUFFER_BIT = $00000100;
  GL_ACCUM_BUFFER_BIT = $00000200;
  GL_STENCIL_BUFFER_BIT = $00000400;
  GL_VIEWPORT_BIT = $00000800;
  GL_TRANSFORM_BIT = $00001000;
  GL_ENABLE_BIT = $00002000;
  GL_COLOR_BUFFER_BIT = $00004000;
  GL_HINT_BIT = $00008000;
  GL_EVAL_BIT = $00010000;
  GL_LIST_BIT = $00020000;
  GL_TEXTURE_BIT = $00040000;
  GL_SCISSOR_BIT = $00080000;
  GL_ALL_ATTRIB_BITS = $000fffff;

{ ClearBufferMask }

{      GL_COLOR_BUFFER_BIT }

{      GL_ACCUM_BUFFER_BIT }

{      GL_STENCIL_BUFFER_BIT }

{      GL_DEPTH_BUFFER_BIT }

{ ClientAttribMask }

const
  GL_CLIENT_PIXEL_STORE_BIT = $00000001;
  GL_CLIENT_VERTEX_ARRAY_BIT = $00000002;
  GL_CLIENT_ALL_ATTRIB_BITS = $FFFFFFFF;

{ Boolean }

const
  GL_FALSE = 0;
  GL_TRUE = 1;

{ BeginMode }

const
  GL_POINTS = $0000;
  GL_LINES = $0001;
  GL_LINE_LOOP = $0002;
  GL_LINE_STRIP = $0003;
  GL_TRIANGLES = $0004;
  GL_TRIANGLE_STRIP = $0005;
  GL_TRIANGLE_FAN = $0006;
  GL_QUADS = $0007;
  GL_QUAD_STRIP = $0008;
  GL_POLYGON = $0009;

{ AccumOp }

const
  GL_ACCUM = $0100;
  GL_LOAD = $0101;
  GL_RETURN = $0102;
  GL_MULT = $0103;
  GL_ADD = $0104;

{ AlphaFunction }

const
  GL_NEVER = $0200;
  GL_LESS = $0201;
  GL_EQUAL = $0202;
  GL_LEQUAL = $0203;
  GL_GREATER = $0204;
  GL_NOTEQUAL = $0205;
  GL_GEQUAL = $0206;
  GL_ALWAYS = $0207;

{ BlendingFactorDest }

const
  GL_ZERO = 0;
  GL_ONE = 1;
  GL_SRC_COLOR = $0300;
  GL_ONE_MINUS_SRC_COLOR = $0301;
  GL_SRC_ALPHA = $0302;
  GL_ONE_MINUS_SRC_ALPHA = $0303;
  GL_DST_ALPHA = $0304;
  GL_ONE_MINUS_DST_ALPHA = $0305;

{ BlendingFactorSrc }

{      GL_ZERO }

{      GL_ONE }

const
  GL_DST_COLOR = $0306;
  GL_ONE_MINUS_DST_COLOR = $0307;
  GL_SRC_ALPHA_SATURATE = $0308;

{      GL_SRC_ALPHA }

{      GL_ONE_MINUS_SRC_ALPHA }

{      GL_DST_ALPHA }

{      GL_ONE_MINUS_DST_ALPHA }

{ ColorMaterialFace }

{      GL_FRONT }

{      GL_BACK }

{      GL_FRONT_AND_BACK }

{ ColorMaterialParameter }

{      GL_AMBIENT }

{      GL_DIFFUSE }

{      GL_SPECULAR }

{      GL_EMISSION }

{      GL_AMBIENT_AND_DIFFUSE }

{ ColorPointerType }

{      GL_BYTE }

{      GL_UNSIGNED_BYTE }

{      GL_SHORT }

{      GL_UNSIGNED_SHORT }

{      GL_INT }

{      GL_UNSIGNED_INT }

{      GL_FLOAT }

{      GL_DOUBLE }

{ CullFaceMode }

{      GL_FRONT }

{      GL_BACK }

{      GL_FRONT_AND_BACK }

{ CullParameterSGI }

{      GL_CULL_VERTEX_EYE_POSITION_SGI }

{      GL_CULL_VERTEX_OBJECT_POSITION_SGI }

{ DepthFunction }

{      GL_NEVER }

{      GL_LESS }

{      GL_EQUAL }

{      GL_LEQUAL }

{      GL_GREATER }

{      GL_NOTEQUAL }

{      GL_GEQUAL }

{      GL_ALWAYS }

{ DrawBufferMode }

const
  GL_NONE = 0;
  GL_FRONT_LEFT = $0400;
  GL_FRONT_RIGHT = $0401;
  GL_BACK_LEFT = $0402;
  GL_BACK_RIGHT = $0403;
  GL_FRONT = $0404;
  GL_BACK = $0405;
  GL_LEFT = $0406;
  GL_RIGHT = $0407;
  GL_FRONT_AND_BACK = $0408;
  GL_AUX0 = $0409;
  GL_AUX1 = $040A;
  GL_AUX2 = $040;
  GL_AUX3 = $040C;

{ EnableCap }

{      GL_FOG }

{      GL_LIGHTING }

{      GL_TEXTURE_1D }

{      GL_TEXTURE_2D }

{      GL_LINE_STIPPLE }

{      GL_POLYGON_STIPPLE }

{      GL_CULL_FACE }

{      GL_ALPHA_TEST }

{      GL_BLEND }

{      GL_INDEX_LOGIC_OP }

{      GL_COLOR_LOGIC_OP }

{      GL_DITHER }

{      GL_STENCIL_TEST }

{      GL_DEPTH_TEST }

{      GL_CLIP_PLANE0 }

{      GL_CLIP_PLANE1 }

{      GL_CLIP_PLANE2 }

{      GL_CLIP_PLANE3 }

{      GL_CLIP_PLANE4 }

{      GL_CLIP_PLANE5 }

{      GL_LIGHT0 }

{      GL_LIGHT1 }

{      GL_LIGHT2 }

{      GL_LIGHT3 }

{      GL_LIGHT4 }

{      GL_LIGHT5 }

{      GL_LIGHT6 }

{      GL_LIGHT7 }

{      GL_TEXTURE_GEN_S }

{      GL_TEXTURE_GEN_T }

{      GL_TEXTURE_GEN_R }

{      GL_TEXTURE_GEN_Q }

{      GL_MAP1_VERTEX_3 }

{      GL_MAP1_VERTEX_4 }

{      GL_MAP1_COLOR_4 }

{      GL_MAP1_INDEX }

{      GL_MAP1_NORMAL }

{      GL_MAP1_TEXTURE_COORD_1 }

{      GL_MAP1_TEXTURE_COORD_2 }

{      GL_MAP1_TEXTURE_COORD_3 }

{      GL_MAP1_TEXTURE_COORD_4 }

{      GL_MAP2_VERTEX_3 }

{      GL_MAP2_VERTEX_4 }

{      GL_MAP2_COLOR_4 }

{      GL_MAP2_INDEX }

{      GL_MAP2_NORMAL }

{      GL_MAP2_TEXTURE_COORD_1 }

{      GL_MAP2_TEXTURE_COORD_2 }

{      GL_MAP2_TEXTURE_COORD_3 }

{      GL_MAP2_TEXTURE_COORD_4 }

{      GL_POINT_SMOOTH }

{      GL_LINE_SMOOTH }

{      GL_POLYGON_SMOOTH }

{      GL_SCISSOR_TEST }

{      GL_COLOR_MATERIAL }

{      GL_NORMALIZE }

{      GL_AUTO_NORMAL }

{      GL_POLYGON_OFFSET_POINT }

{      GL_POLYGON_OFFSET_LINE }

{      GL_POLYGON_OFFSET_FILL }

{      GL_VERTEX_ARRAY }

{      GL_NORMAL_ARRAY }

{      GL_COLOR_ARRAY }

{      GL_INDEX_ARRAY }

{      GL_TEXTURE_COORD_ARRAY }

{      GL_EDGE_FLAG_ARRAY }

{      GL_CULL_VERTEX_SGI }

{      GL_INDEX_MATERIAL_SGI }

{      GL_INDEX_TEST_SGI }

{ ErrorCode }

const
  GL_NO_ERROR = 0;
  GL_INVALID_ENUM = $0500;
  GL_INVALID_VALUE = $0501;
  GL_INVALID_OPERATION = $0502;
  GL_STACK_OVERFLOW = $0503;
  GL_STACK_UNDERFLOW = $0504;
  GL_OUT_OF_MEMORY = $0505;

{      GL_TABLE_TOO_LARGE_EXT }

{ FeedbackType }

const
  GL_2D = $0600;
  GL_3D = $0601;
  GL_3D_COLOR = $0602;
  GL_3D_COLOR_TEXTURE = $0603;
  GL_4D_COLOR_TEXTURE = $0604;

{ FeedBackToken }

const
  GL_PASS_THROUGH_TOKEN = $0700;
  GL_POINT_TOKEN = $0701;
  GL_LINE_TOKEN = $0702;
  GL_POLYGON_TOKEN = $0703;
  GL_BITMAP_TOKEN = $0704;
  GL_DRAW_PIXEL_TOKEN = $0705;
  GL_COPY_PIXEL_TOKEN = $0706;
  GL_LINE_RESET_TOKEN = $0707;

{ FogMode }

{      GL_LINEAR }

const
  GL_EXP = $0800;
  GL_EXP2 = $0801;

{ FogParameter }

{      GL_FOG_COLOR }

{      GL_FOG_DENSITY }

{      GL_FOG_END }

{      GL_FOG_INDEX }

{      GL_FOG_MODE }

{      GL_FOG_START }

{ FrontFaceDirection }

const
  GL_CW = $0900;
  GL_CCW = $0901;

{ GetColorTableParameterPNameEXT }

{      GL_COLOR_TABLE_FORMAT_EXT }

{      GL_COLOR_TABLE_WIDTH_EXT }

{      GL_COLOR_TABLE_RED_SIZE_EXT }

{      GL_COLOR_TABLE_GREEN_SIZE_EXT }

{      GL_COLOR_TABLE_BLUE_SIZE_EXT }

{      GL_COLOR_TABLE_ALPHA_SIZE_EXT }

{      GL_COLOR_TABLE_LUMINANCE_SIZE_EXT }

{      GL_COLOR_TABLE_INTENSITY_SIZE_EXT }

{ GetMapQuery }

const
  GL_COEFF = $0A00;
  GL_ORDER = $0A01;
  GL_DOMAIN = $0A02;

{ GetPixelMap }

const
  GL_PIXEL_MAP_I_TO_I = $0C70;
  GL_PIXEL_MAP_S_TO_S = $0C71;
  GL_PIXEL_MAP_I_TO_R = $0C72;
  GL_PIXEL_MAP_I_TO_G = $0C73;
  GL_PIXEL_MAP_I_TO_B = $0C74;
  GL_PIXEL_MAP_I_TO_A = $0C75;
  GL_PIXEL_MAP_R_TO_R = $0C76;
  GL_PIXEL_MAP_G_TO_G = $0C77;
  GL_PIXEL_MAP_B_TO_B = $0C78;
  GL_PIXEL_MAP_A_TO_A = $0C79;

{ GetPointervPName }

const
  GL_VERTEX_ARRAY_POINTER = $808E;
  GL_NORMAL_ARRAY_POINTER = $808F;
  GL_COLOR_ARRAY_POINTER = $8090;
  GL_INDEX_ARRAY_POINTER = $8091;
  GL_TEXTURE_COORD_ARRAY_POINTER = $8092;
  GL_EDGE_FLAG_ARRAY_POINTER = $8093;

{ GetPName }

const
  GL_CURRENT_COLOR = $0B00;
  GL_CURRENT_INDEX = $0B01;
  GL_CURRENT_NORMAL = $0B02;
  GL_CURRENT_TEXTURE_COORDS = $0B03;
  GL_CURRENT_RASTER_COLOR = $0B04;
  GL_CURRENT_RASTER_INDEX = $0B05;
  GL_CURRENT_RASTER_TEXTURE_COORDS = $0B06;
  GL_CURRENT_RASTER_POSITION = $0B07;
  GL_CURRENT_RASTER_POSITION_VALID = $0B08;
  GL_CURRENT_RASTER_DISTANCE = $0B09;
  GL_POINT_SMOOTH = $0B10;
  GL_POINT_SIZE = $0B11;
  GL_POINT_SIZE_RANGE = $0B12;
  GL_POINT_SIZE_GRANULARITY = $0B13;
  GL_LINE_SMOOTH = $0B20;
  GL_LINE_WIDTH = $0B21;
  GL_LINE_WIDTH_RANGE = $0B22;
  GL_LINE_WIDTH_GRANULARITY = $0B23;
  GL_LINE_STIPPLE = $0B24;
  GL_LINE_STIPPLE_PATTERN = $0B25;
  GL_LINE_STIPPLE_REPEAT = $0B26;
  GL_LIST_MODE = $0B30;
  GL_MAX_LIST_NESTING = $0B31;
  GL_LIST_BASE = $0B32;
  GL_LIST_INDEX = $0B33;
  GL_POLYGON_MODE = $0B40;
  GL_POLYGON_SMOOTH = $0B41;
  GL_POLYGON_STIPPLE = $0B42;
  GL_EDGE_FLAG = $0B43;
  GL_CULL_FACE = $0B44;
  GL_CULL_FACE_MODE = $0B45;
  GL_FRONT_FACE = $0B46;
  GL_LIGHTING = $0B50;
  GL_LIGHT_MODEL_LOCAL_VIEWER = $0B51;
  GL_LIGHT_MODEL_TWO_SIDE = $0B52;
  GL_LIGHT_MODEL_AMBIENT = $0B53;
  GL_SHADE_MODEL = $0B54;
  GL_COLOR_MATERIAL_FACE = $0B55;
  GL_COLOR_MATERIAL_PARAMETER = $0B56;
  GL_COLOR_MATERIAL = $0B57;
  GL_FOG = $0B60;
  GL_FOG_INDEX = $0B61;
  GL_FOG_DENSITY = $0B62;
  GL_FOG_START = $0B63;
  GL_FOG_END = $0B64;
  GL_FOG_MODE = $0B65;
  GL_FOG_COLOR = $0B66;
  GL_DEPTH_RANGE = $0B70;
  GL_DEPTH_TEST = $0B71;
  GL_DEPTH_WRITEMASK = $0B72;
  GL_DEPTH_CLEAR_VALUE = $0B73;
  GL_DEPTH_FUNC = $0B74;
  GL_ACCUM_CLEAR_VALUE = $0B80;
  GL_STENCIL_TEST = $0B90;
  GL_STENCIL_CLEAR_VALUE = $0B91;
  GL_STENCIL_FUNC = $0B92;
  GL_STENCIL_VALUE_MASK = $0B93;
  GL_STENCIL_FAIL = $0B94;
  GL_STENCIL_PASS_DEPTH_FAIL = $0B95;
  GL_STENCIL_PASS_DEPTH_PASS = $0B96;
  GL_STENCIL_REF = $0B97;
  GL_STENCIL_WRITEMASK = $0B98;
  GL_MATRIX_MODE = $0BA0;
  GL_NORMALIZE = $0BA1;
  GL_VIEWPORT = $0BA2;
  GL_MODELVIEW_STACK_DEPTH = $0BA3;
  GL_PROJECTION_STACK_DEPTH = $0BA4;
  GL_TEXTURE_STACK_DEPTH = $0BA5;
  GL_MODELVIEW_MATRIX = $0BA6;
  GL_PROJECTION_MATRIX = $0BA7;
  GL_TEXTURE_MATRIX = $0BA8;
  GL_ATTRIB_STACK_DEPTH = $0BB0;
  GL_CLIENT_ATTRIB_STACK_DEPTH = $0BB1;
  GL_ALPHA_TEST = $0BC0;
  GL_ALPHA_TEST_FUNC = $0BC1;
  GL_ALPHA_TEST_REF = $0BC2;
  GL_DITHER = $0BD0;
  GL_BLEND_DST = $0BE0;
  GL_BLEND_SRC = $0BE1;
  GL_BLEND = $0BE2;
  GL_LOGIC_OP_MODE = $0BF0;
  GL_INDEX_LOGIC_OP = $0BF1;
  GL_LOGIC_OP = $0BF1;
  GL_COLOR_LOGIC_OP = $0BF2;
  GL_AUX_BUFFERS = $0C00;
  GL_DRAW_BUFFER = $0C01;
  GL_READ_BUFFER = $0C02;
  GL_SCISSOR_BOX = $0C10;
  GL_SCISSOR_TEST = $0C11;
  GL_INDEX_CLEAR_VALUE = $0C20;
  GL_INDEX_WRITEMASK = $0C21;
  GL_COLOR_CLEAR_VALUE = $0C22;
  GL_COLOR_WRITEMASK = $0C23;
  GL_INDEX_MODE = $0C30;
  GL_RGBA_MODE = $0C31;
  GL_DOUBLEBUFFER = $0C32;
  GL_STEREO = $0C33;
  GL_RENDER_MODE = $0C40;
  GL_PERSPECTIVE_CORRECTION_HINT = $0C50;
  GL_POINT_SMOOTH_HINT = $0C51;
  GL_LINE_SMOOTH_HINT = $0C52;
  GL_POLYGON_SMOOTH_HINT = $0C53;
  GL_FOG_HINT = $0C54;
  GL_TEXTURE_GEN_S = $0C60;
  GL_TEXTURE_GEN_T = $0C61;
  GL_TEXTURE_GEN_R = $0C62;
  GL_TEXTURE_GEN_Q = $0C63;
  GL_PIXEL_MAP_I_TO_I_SIZE = $0CB0;
  GL_PIXEL_MAP_S_TO_S_SIZE = $0CB1;
  GL_PIXEL_MAP_I_TO_R_SIZE = $0CB2;
  GL_PIXEL_MAP_I_TO_G_SIZE = $0CB3;
  GL_PIXEL_MAP_I_TO_B_SIZE = $0CB4;
  GL_PIXEL_MAP_I_TO_A_SIZE = $0CB5;
  GL_PIXEL_MAP_R_TO_R_SIZE = $0CB6;
  GL_PIXEL_MAP_G_TO_G_SIZE = $0CB7;
  GL_PIXEL_MAP_B_TO_B_SIZE = $0CB8;
  GL_PIXEL_MAP_A_TO_A_SIZE = $0CB9;
  GL_UNPACK_SWAP_BYTES = $0CF0;
  GL_UNPACK_LSB_FIRST = $0CF1;
  GL_UNPACK_ROW_LENGTH = $0CF2;
  GL_UNPACK_SKIP_ROWS = $0CF3;
  GL_UNPACK_SKIP_PIXELS = $0CF4;
  GL_UNPACK_ALIGNMENT = $0CF5;
  GL_PACK_SWAP_BYTES = $0D00;
  GL_PACK_LSB_FIRST = $0D01;
  GL_PACK_ROW_LENGTH = $0D02;
  GL_PACK_SKIP_ROWS = $0D03;
  GL_PACK_SKIP_PIXELS = $0D04;
  GL_PACK_ALIGNMENT = $0D05;
  GL_MAP_COLOR = $0D10;
  GL_MAP_STENCIL = $0D11;
  GL_INDEX_SHIFT = $0D12;
  GL_INDEX_OFFSET = $0D13;
  GL_RED_SCALE = $0D14;
  GL_RED_BIAS = $0D15;
  GL_ZOOM_X = $0D16;
  GL_ZOOM_Y = $0D17;
  GL_GREEN_SCALE = $0D18;
  GL_GREEN_BIAS = $0D19;
  GL_BLUE_SCALE = $0D1A;
  GL_BLUE_BIAS = $0D1;
  GL_ALPHA_SCALE = $0D1C;
  GL_ALPHA_BIAS = $0D1D;
  GL_DEPTH_SCALE = $0D1E;
  GL_DEPTH_BIAS = $0D1F;
  GL_MAX_EVAL_ORDER = $0D30;
  GL_MAX_LIGHTS = $0D31;
  GL_MAX_CLIP_PLANES = $0D32;
  GL_MAX_TEXTURE_SIZE = $0D33;
  GL_MAX_PIXEL_MAP_TABLE = $0D34;
  GL_MAX_ATTRIB_STACK_DEPTH = $0D35;
  GL_MAX_MODELVIEW_STACK_DEPTH = $0D36;
  GL_MAX_NAME_STACK_DEPTH = $0D37;
  GL_MAX_PROJECTION_STACK_DEPTH = $0D38;
  GL_MAX_TEXTURE_STACK_DEPTH = $0D39;
  GL_MAX_VIEWPORT_DIMS = $0D3A;
  GL_MAX_CLIENT_ATTRIB_STACK_DEPTH = $0D3;
  GL_SUBPIXEL_BITS = $0D50;
  GL_INDEX_BITS = $0D51;
  GL_RED_BITS = $0D52;
  GL_GREEN_BITS = $0D53;
  GL_BLUE_BITS = $0D54;
  GL_ALPHA_BITS = $0D55;
  GL_DEPTH_BITS = $0D56;
  GL_STENCIL_BITS = $0D57;
  GL_ACCUM_RED_BITS = $0D58;
  GL_ACCUM_GREEN_BITS = $0D59;
  GL_ACCUM_BLUE_BITS = $0D5A;
  GL_ACCUM_ALPHA_BITS = $0D5;
  GL_NAME_STACK_DEPTH = $0D70;
  GL_AUTO_NORMAL = $0D80;
  GL_MAP1_COLOR_4 = $0D90;
  GL_MAP1_INDEX = $0D91;
  GL_MAP1_NORMAL = $0D92;
  GL_MAP1_TEXTURE_COORD_1 = $0D93;
  GL_MAP1_TEXTURE_COORD_2 = $0D94;
  GL_MAP1_TEXTURE_COORD_3 = $0D95;
  GL_MAP1_TEXTURE_COORD_4 = $0D96;
  GL_MAP1_VERTEX_3 = $0D97;
  GL_MAP1_VERTEX_4 = $0D98;
  GL_MAP2_COLOR_4 = $0DB0;
  GL_MAP2_INDEX = $0DB1;
  GL_MAP2_NORMAL = $0DB2;
  GL_MAP2_TEXTURE_COORD_1 = $0DB3;
  GL_MAP2_TEXTURE_COORD_2 = $0DB4;
  GL_MAP2_TEXTURE_COORD_3 = $0DB5;
  GL_MAP2_TEXTURE_COORD_4 = $0DB6;
  GL_MAP2_VERTEX_3 = $0DB7;
  GL_MAP2_VERTEX_4 = $0DB8;
  GL_MAP1_GRID_DOMAIN = $0DD0;
  GL_MAP1_GRID_SEGMENTS = $0DD1;
  GL_MAP2_GRID_DOMAIN = $0DD2;
  GL_MAP2_GRID_SEGMENTS = $0DD3;
  GL_TEXTURE_1D = $0DE0;
  GL_TEXTURE_2D = $0DE1;
  GL_FEEDBACK_BUFFER_POINTER = $0DF0;
  GL_FEEDBACK_BUFFER_SIZE = $0DF1;
  GL_FEEDBACK_BUFFER_TYPE = $0DF2;
  GL_SELECTION_BUFFER_POINTER = $0DF3;
  GL_SELECTION_BUFFER_SIZE = $0DF4;
  GL_POLYGON_OFFSET_UNITS = $2A00;
  GL_POLYGON_OFFSET_POINT = $2A01;
  GL_POLYGON_OFFSET_LINE = $2A02;
  GL_POLYGON_OFFSET_FILL = $8037;
  GL_POLYGON_OFFSET_FACTOR = $8038;
  GL_TEXTURE_BINDING_1D = $8068;
  GL_TEXTURE_BINDING_2D = $8069;
  GL_VERTEX_ARRAY = $8074;
  GL_NORMAL_ARRAY = $8075;
  GL_COLOR_ARRAY = $8076;
  GL_INDEX_ARRAY = $8077;
  GL_TEXTURE_COORD_ARRAY = $8078;
  GL_EDGE_FLAG_ARRAY = $8079;
  GL_VERTEX_ARRAY_SIZE = $807A;
  GL_VERTEX_ARRAY_TYPE = $807;
  GL_VERTEX_ARRAY_STRIDE = $807C;
  GL_NORMAL_ARRAY_TYPE = $807E;
  GL_NORMAL_ARRAY_STRIDE = $807F;
  GL_COLOR_ARRAY_SIZE = $8081;
  GL_COLOR_ARRAY_TYPE = $8082;
  GL_COLOR_ARRAY_STRIDE = $8083;
  GL_INDEX_ARRAY_TYPE = $8085;
  GL_INDEX_ARRAY_STRIDE = $8086;
  GL_TEXTURE_COORD_ARRAY_SIZE = $8088;
  GL_TEXTURE_COORD_ARRAY_TYPE = $8089;
  GL_TEXTURE_COORD_ARRAY_STRIDE = $808A;
  GL_EDGE_FLAG_ARRAY_STRIDE = $808C;

{      GL_VERTEX_ARRAY_COUNT_EXT }

{      GL_NORMAL_ARRAY_COUNT_EXT }

{      GL_COLOR_ARRAY_COUNT_EXT }

{      GL_INDEX_ARRAY_COUNT_EXT }

{      GL_TEXTURE_COORD_ARRAY_COUNT_EXT }

{      GL_EDGE_FLAG_ARRAY_COUNT_EXT }

{      GL_ARRAY_ELEMENT_LOCK_COUNT_SGI }

{      GL_ARRAY_ELEMENT_LOCK_FIRST_SGI }

{      GL_INDEX_TEST_SGI }

{      GL_INDEX_TEST_FUNC_SGI }

{      GL_INDEX_TEST_REF_SGI }

{      GL_INDEX_MATERIAL_SGI }

{      GL_INDEX_MATERIAL_FACE_SGI }

{      GL_INDEX_MATERIAL_PARAMETER_SGI }

{ GetTextureParameter }

{      GL_TEXTURE_MAG_FILTER }

{      GL_TEXTURE_MIN_FILTER }

{      GL_TEXTURE_WRAP_S }

{      GL_TEXTURE_WRAP_T }

const
  GL_TEXTURE_WIDTH = $1000;
  GL_TEXTURE_HEIGHT = $1001;
  GL_TEXTURE_INTERNAL_FORMAT = $1003;
  GL_TEXTURE_COMPONENTS = $1003;
  GL_TEXTURE_BORDER_COLOR = $1004;
  GL_TEXTURE_BORDER = $1005;
  GL_TEXTURE_RED_SIZE = $805C;
  GL_TEXTURE_GREEN_SIZE = $805D;
  GL_TEXTURE_BLUE_SIZE = $805E;
  GL_TEXTURE_ALPHA_SIZE = $805F;
  GL_TEXTURE_LUMINANCE_SIZE = $8060;
  GL_TEXTURE_INTENSITY_SIZE = $8061;
  GL_TEXTURE_PRIORITY = $8066;
  GL_TEXTURE_RESIDENT = $8067;

{ HintMode }

const
  GL_DONT_CARE = $1100;
  GL_FASTEST = $1101;
  GL_NICEST = $1102;

{ HintTarget }

{      GL_PERSPECTIVE_CORRECTION_HINT }

{      GL_POINT_SMOOTH_HINT }

{      GL_LINE_SMOOTH_HINT }

{      GL_POLYGON_SMOOTH_HINT }

{      GL_FOG_HINT }

{ IndexMaterialParameterSGI }

{      GL_INDEX_OFFSET }

{ IndexPointerType }

{      GL_SHORT }

{      GL_INT }

{      GL_FLOAT }

{      GL_DOUBLE }

{ IndexFunctionSGI }

{      GL_NEVER }

{      GL_LESS }

{      GL_EQUAL }

{      GL_LEQUAL }

{      GL_GREATER }

{      GL_NOTEQUAL }

{      GL_GEQUAL }

{      GL_ALWAYS }

{ LightModelParameter }

{      GL_LIGHT_MODEL_AMBIENT }

{      GL_LIGHT_MODEL_LOCAL_VIEWER }

{      GL_LIGHT_MODEL_TWO_SIDE }

{ LightParameter }

const
  GL_AMBIENT = $1200;
  GL_DIFFUSE = $1201;
  GL_SPECULAR = $1202;
  GL_POSITION = $1203;
  GL_SPOT_DIRECTION = $1204;
  GL_SPOT_EXPONENT = $1205;
  GL_SPOT_CUTOFF = $1206;
  GL_CONSTANT_ATTENUATION = $1207;
  GL_LINEAR_ATTENUATION = $1208;
  GL_QUADRATIC_ATTENUATION = $1209;

{ ListMode }

const
  GL_COMPILE = $1300;
  GL_COMPILE_AND_EXECUTE = $1301;

{ DataType }

const
  GL_BYTE = $1400;
  GL_UNSIGNED_BYTE = $1401;
  GL_SHORT = $1402;
  GL_UNSIGNED_SHORT = $1403;
  GL_INT = $1404;
  GL_UNSIGNED_INT = $1405;
  GL_FLOAT = $1406;
  GL_2_BYTES = $1407;
  GL_3_BYTES = $1408;
  GL_4_BYTES = $1409;
  GL_DOUBLE = $140A;
  GL_DOUBLE_EXT = $140A;

{ ListNameType }

{      GL_BYTE }

{      GL_UNSIGNED_BYTE }

{      GL_SHORT }

{      GL_UNSIGNED_SHORT }

{      GL_INT }

{      GL_UNSIGNED_INT }

{      GL_FLOAT }

{      GL_2_BYTES }

{      GL_3_BYTES }

{      GL_4_BYTES }

{ LogicOp }

const
  GL_CLEAR = $1500;
  GL_AND = $1501;
  GL_AND_REVERSE = $1502;
  GL_COPY = $1503;
  GL_AND_INVERTED = $1504;
  GL_NOOP = $1505;
  GL_XOR = $1506;
  GL_OR = $1507;
  GL_NOR = $1508;
  GL_EQUIV = $1509;
  GL_INVERT = $150A;
  GL_OR_REVERSE = $150;
  GL_COPY_INVERTED = $150C;
  GL_OR_INVERTED = $150D;
  GL_NAND = $150E;
  GL_SET = $150F;

{ MapTarget }

{      GL_MAP1_COLOR_4 }

{      GL_MAP1_INDEX }

{      GL_MAP1_NORMAL }

{      GL_MAP1_TEXTURE_COORD_1 }

{      GL_MAP1_TEXTURE_COORD_2 }

{      GL_MAP1_TEXTURE_COORD_3 }

{      GL_MAP1_TEXTURE_COORD_4 }

{      GL_MAP1_VERTEX_3 }

{      GL_MAP1_VERTEX_4 }

{      GL_MAP2_COLOR_4 }

{      GL_MAP2_INDEX }

{      GL_MAP2_NORMAL }

{      GL_MAP2_TEXTURE_COORD_1 }

{      GL_MAP2_TEXTURE_COORD_2 }

{      GL_MAP2_TEXTURE_COORD_3 }

{      GL_MAP2_TEXTURE_COORD_4 }

{      GL_MAP2_VERTEX_3 }

{      GL_MAP2_VERTEX_4 }

{ MaterialFace }

{      GL_FRONT }

{      GL_BACK }

{      GL_FRONT_AND_BACK }

{ MaterialParameter }

const
  GL_EMISSION = $1600;
  GL_SHININESS = $1601;
  GL_AMBIENT_AND_DIFFUSE = $1602;
  GL_COLOR_INDEXES = $1603;

{      GL_AMBIENT }

{      GL_DIFFUSE }

{      GL_SPECULAR }

{ MatrixMode }

const
  GL_MODELVIEW = $1700;
  GL_PROJECTION = $1701;
  GL_TEXTURE = $1702;

{ MeshMode1 }

{      GL_POINT }

{      GL_LINE }

{ MeshMode2 }

{      GL_POINT }

{      GL_LINE }

{      GL_FILL }

{ NormalPointerType }

{      GL_BYTE }

{      GL_SHORT }

{      GL_INT }

{      GL_FLOAT }

{      GL_DOUBLE }

{ PixelCopyType }

const
  GL_COLOR = $1800;
  GL_DEPTH = $1801;
  GL_STENCIL = $1802;

{ PixelFormat }

const
  GL_COLOR_INDEX = $1900;
  GL_STENCIL_INDEX = $1901;
  GL_DEPTH_COMPONENT = $1902;
  GL_RED = $1903;
  GL_GREEN = $1904;
  GL_BLUE = $1905;
  GL_ALPHA = $1906;
  GL_RGB = $1907;
  GL_RGBA = $1908;
  GL_LUMINANCE = $1909;
  GL_LUMINANCE_ALPHA = $190A;

{      GL_ABGR_EXT }

{      GL_BGR_EXT }

{      GL_BGRA_EXT }

{ PixelMap }

{      GL_PIXEL_MAP_I_TO_I }

{      GL_PIXEL_MAP_S_TO_S }

{      GL_PIXEL_MAP_I_TO_R }

{      GL_PIXEL_MAP_I_TO_G }

{      GL_PIXEL_MAP_I_TO_B }

{      GL_PIXEL_MAP_I_TO_A }

{      GL_PIXEL_MAP_R_TO_R }

{      GL_PIXEL_MAP_G_TO_G }

{      GL_PIXEL_MAP_B_TO_B }

{      GL_PIXEL_MAP_A_TO_A }

{ PixelStoreParameter }

{      GL_UNPACK_SWAP_BYTES }

{      GL_UNPACK_LSB_FIRST }

{      GL_UNPACK_ROW_LENGTH }

{      GL_UNPACK_SKIP_ROWS }

{      GL_UNPACK_SKIP_PIXELS }

{      GL_UNPACK_ALIGNMENT }

{      GL_PACK_SWAP_BYTES }

{      GL_PACK_LSB_FIRST }

{      GL_PACK_ROW_LENGTH }

{      GL_PACK_SKIP_ROWS }

{      GL_PACK_SKIP_PIXELS }

{      GL_PACK_ALIGNMENT }

{ PixelTransferParameter }

{      GL_MAP_COLOR }

{      GL_MAP_STENCIL }

{      GL_INDEX_SHIFT }

{      GL_INDEX_OFFSET }

{      GL_RED_SCALE }

{      GL_RED_BIAS }

{      GL_GREEN_SCALE }

{      GL_GREEN_BIAS }

{      GL_BLUE_SCALE }

{      GL_BLUE_BIAS }

{      GL_ALPHA_SCALE }

{      GL_ALPHA_BIAS }

{      GL_DEPTH_SCALE }

{      GL_DEPTH_BIAS }

{ PixelType }

const
  GL_BITMAP = $1A00;

{      GL_BYTE }

{      GL_UNSIGNED_BYTE }

{      GL_SHORT }

{      GL_UNSIGNED_SHORT }

{      GL_INT }

{      GL_UNSIGNED_INT }

{      GL_FLOAT }

{      GL_UNSIGNED_BYTE_3_3_2_EXT }

{      GL_UNSIGNED_SHORT_4_4_4_4_EXT }

{      GL_UNSIGNED_SHORT_5_5_5_1_EXT }

{      GL_UNSIGNED_INT_8_8_8_8_EXT }

{      GL_UNSIGNED_INT_10_10_10_2_EXT }

{ PolygonMode }

const
  GL_POINT = $1B00;
  GL_LINE = $1B01;
  GL_FILL = $1B02;

{ ReadBufferMode }

{      GL_FRONT_LEFT }

{      GL_FRONT_RIGHT }

{      GL_BACK_LEFT }

{      GL_BACK_RIGHT }

{      GL_FRONT }

{      GL_BACK }

{      GL_LEFT }

{      GL_RIGHT }

{      GL_AUX0 }

{      GL_AUX1 }

{      GL_AUX2 }

{      GL_AUX3 }

{ RenderingMode }

const
  GL_RENDER = $1C00;
  GL_FEEDBACK = $1C01;
  GL_SELECT = $1C02;

{ ShadingModel }

const
  GL_FLAT = $1D00;
  GL_SMOOTH = $1D01;

{ StencilFunction }

{      GL_NEVER }

{      GL_LESS }

{      GL_EQUAL }

{      GL_LEQUAL }

{      GL_GREATER }

{      GL_NOTEQUAL }

{      GL_GEQUAL }

{      GL_ALWAYS }

{ StencilOp }

{      GL_ZERO }

const
  GL_KEEP = $1E00;
  GL_REPLACE = $1E01;
  GL_INCR = $1E02;
  GL_DECR = $1E03;

{      GL_INVERT }

{ StringName }

const
  GL_VENDOR = $1F00;
  GL_RENDERER = $1F01;
  GL_VERSION = $1F02;
  GL_EXTENSIONS = $1F03;

{ TexCoordPointerType }

{      GL_SHORT }

{      GL_INT }

{      GL_FLOAT }

{      GL_DOUBLE }

{ TextureCoordName }

const
  GL_S = $2000;
  GL_T = $2001;
  GL_R = $2002;
  GL_Q = $2003;

{ TextureEnvMode }

const
  GL_MODULATE = $2100;
  GL_DECAL = $2101;

{      GL_BLEND }

{      GL_REPLACE }

{      GL_ADD }

{ TextureEnvParameter }

const
  GL_TEXTURE_ENV_MODE = $2200;
  GL_TEXTURE_ENV_COLOR = $2201;

{ TextureEnvTarget }

const
  GL_TEXTURE_ENV = $2300;

{ TextureGenMode }

const
  GL_EYE_LINEAR = $2400;
  GL_OBJECT_LINEAR = $2401;
  GL_SPHERE_MAP = $2402;

{ TextureGenParameter }

const
  GL_TEXTURE_GEN_MODE = $2500;
  GL_OBJECT_PLANE = $2501;
  GL_EYE_PLANE = $2502;

{ TextureMagFilter }

const
  GL_NEAREST = $2600;
  GL_LINEAR = $2601;

{ TextureMinFilter }

{      GL_NEAREST }

{      GL_LINEAR }

const
  GL_NEAREST_MIPMAP_NEAREST = $2700;
  GL_LINEAR_MIPMAP_NEAREST = $2701;
  GL_NEAREST_MIPMAP_LINEAR = $2702;
  GL_LINEAR_MIPMAP_LINEAR = $2703;

{ TextureParameterName }

const
  GL_TEXTURE_MAG_FILTER = $2800;
  GL_TEXTURE_MIN_FILTER = $2801;
  GL_TEXTURE_WRAP_S = $2802;
  GL_TEXTURE_WRAP_T = $2803;

{      GL_TEXTURE_BORDER_COLOR }

{      GL_TEXTURE_PRIORITY }

{ TextureTarget }

{      GL_TEXTURE_1D }

{      GL_TEXTURE_2D }

const
  GL_PROXY_TEXTURE_1D = $8063;
  GL_PROXY_TEXTURE_2D = $8064;

{ TextureWrapMode }

const
  GL_CLAMP = $2900;
  GL_REPEAT = $2901;

{ PixelInternalFormat }

const
  GL_R3_G3_B2 = $2A10;
  GL_ALPHA4 = $803;
  GL_ALPHA8 = $803C;
  GL_ALPHA12 = $803D;
  GL_ALPHA16 = $803E;
  GL_LUMINANCE4 = $803F;
  GL_LUMINANCE8 = $8040;
  GL_LUMINANCE12 = $8041;
  GL_LUMINANCE16 = $8042;
  GL_LUMINANCE4_ALPHA4 = $8043;
  GL_LUMINANCE6_ALPHA2 = $8044;
  GL_LUMINANCE8_ALPHA8 = $8045;
  GL_LUMINANCE12_ALPHA4 = $8046;
  GL_LUMINANCE12_ALPHA12 = $8047;
  GL_LUMINANCE16_ALPHA16 = $8048;
  GL_INTENSITY = $8049;
  GL_INTENSITY4 = $804A;
  GL_INTENSITY8 = $804;
  GL_INTENSITY12 = $804C;
  GL_INTENSITY16 = $804D;
  GL_RGB4 = $804F;
  GL_RGB5 = $8050;
  GL_RGB8 = $8051;
  GL_RGB10 = $8052;
  GL_RGB12 = $8053;
  GL_RGB16 = $8054;
  GL_RGBA2 = $8055;
  GL_RGBA4 = $8056;
  GL_RGB5_A1 = $8057;
  GL_RGBA8 = $8058;
  GL_RGB10_A2 = $8059;
  GL_RGBA12 = $805A;
  GL_RGBA16 = $805;

{      GL_COLOR_INDEX1_EXT }

{      GL_COLOR_INDEX2_EXT }

{      GL_COLOR_INDEX4_EXT }

{      GL_COLOR_INDEX8_EXT }

{      GL_COLOR_INDEX12_EXT }

{      GL_COLOR_INDEX16_EXT }

{ InterleavedArrayFormat }

const
  GL_V2F = $2A20;
  GL_V3F = $2A21;
  GL_C4UB_V2F = $2A22;
  GL_C4UB_V3F = $2A23;
  GL_C3F_V3F = $2A24;
  GL_N3F_V3F = $2A25;
  GL_C4F_N3F_V3F = $2A26;
  GL_T2F_V3F = $2A27;
  GL_T4F_V4F = $2A28;
  GL_T2F_C4UB_V3F = $2A29;
  GL_T2F_C3F_V3F = $2A2A;
  GL_T2F_N3F_V3F = $2A2;
  GL_T2F_C4F_N3F_V3F = $2A2C;
  GL_T4F_C4F_N3F_V4F = $2A2D;

{      GL_IUI_V2F_SGI }

{      GL_IUI_V3F_SGI }

{      GL_IUI_N3F_V2F_SGI }

{      GL_IUI_N3F_V3F_SGI }

{      GL_T2F_IUI_V2F_SGI }

{      GL_T2F_IUI_V3F_SGI }

{      GL_T2F_IUI_N3F_V2F_SGI }

{      GL_T2F_IUI_N3F_V3F_SGI }

{ VertexPointerType }

{      GL_SHORT }

{      GL_INT }

{      GL_FLOAT }

{      GL_DOUBLE }

{ ClipPlaneName }

const
  GL_CLIP_PLANE0 = $3000;
  GL_CLIP_PLANE1 = $3001;
  GL_CLIP_PLANE2 = $3002;
  GL_CLIP_PLANE3 = $3003;
  GL_CLIP_PLANE4 = $3004;
  GL_CLIP_PLANE5 = $3005;

{ LightName }

const
  GL_LIGHT0 = $4000;
  GL_LIGHT1 = $4001;
  GL_LIGHT2 = $4002;
  GL_LIGHT3 = $4003;
  GL_LIGHT4 = $4004;
  GL_LIGHT5 = $4005;
  GL_LIGHT6 = $4006;
  GL_LIGHT7 = $4007;

{ EXT_abgr }

const
  GL_ABGR_EXT = $8000;

{ EXT_packed_pixels }

const
  GL_UNSIGNED_BYTE_3_3_2_EXT = $8032;
  GL_UNSIGNED_SHORT_4_4_4_4_EXT = $8033;
  GL_UNSIGNED_SHORT_5_5_5_1_EXT = $8034;
  GL_UNSIGNED_INT_8_8_8_8_EXT = $8035;
  GL_UNSIGNED_INT_10_10_10_2_EXT = $8036;

{ EXT_vertex_array }

const
  GL_VERTEX_ARRAY_EXT = $8074;
  GL_NORMAL_ARRAY_EXT = $8075;
  GL_COLOR_ARRAY_EXT = $8076;
  GL_INDEX_ARRAY_EXT = $8077;
  GL_TEXTURE_COORD_ARRAY_EXT = $8078;
  GL_EDGE_FLAG_ARRAY_EXT = $8079;
  GL_VERTEX_ARRAY_SIZE_EXT = $807A;
  GL_VERTEX_ARRAY_TYPE_EXT = $807;
  GL_VERTEX_ARRAY_STRIDE_EXT = $807C;
  GL_VERTEX_ARRAY_COUNT_EXT = $807D;
  GL_NORMAL_ARRAY_TYPE_EXT = $807E;
  GL_NORMAL_ARRAY_STRIDE_EXT = $807F;
  GL_NORMAL_ARRAY_COUNT_EXT = $8080;
  GL_COLOR_ARRAY_SIZE_EXT = $8081;
  GL_COLOR_ARRAY_TYPE_EXT = $8082;
  GL_COLOR_ARRAY_STRIDE_EXT = $8083;
  GL_COLOR_ARRAY_COUNT_EXT = $8084;
  GL_INDEX_ARRAY_TYPE_EXT = $8085;
  GL_INDEX_ARRAY_STRIDE_EXT = $8086;
  GL_INDEX_ARRAY_COUNT_EXT = $8087;
  GL_TEXTURE_COORD_ARRAY_SIZE_EXT = $8088;
  GL_TEXTURE_COORD_ARRAY_TYPE_EXT = $8089;
  GL_TEXTURE_COORD_ARRAY_STRIDE_EXT = $808A;
  GL_TEXTURE_COORD_ARRAY_COUNT_EXT = $808;
  GL_EDGE_FLAG_ARRAY_STRIDE_EXT = $808C;
  GL_EDGE_FLAG_ARRAY_COUNT_EXT = $808D;
  GL_VERTEX_ARRAY_POINTER_EXT = $808E;
  GL_NORMAL_ARRAY_POINTER_EXT = $808F;
  GL_COLOR_ARRAY_POINTER_EXT = $8090;
  GL_INDEX_ARRAY_POINTER_EXT = $8091;
  GL_TEXTURE_COORD_ARRAY_POINTER_EXT = $8092;
  GL_EDGE_FLAG_ARRAY_POINTER_EXT = $8093;

{ EXT_color_table }

const
  GL_TABLE_TOO_LARGE_EXT = $8031;
  GL_COLOR_TABLE_FORMAT_EXT = $80D8;
  GL_COLOR_TABLE_WIDTH_EXT = $80D9;
  GL_COLOR_TABLE_RED_SIZE_EXT = $80DA;
  GL_COLOR_TABLE_GREEN_SIZE_EXT = $80D;
  GL_COLOR_TABLE_BLUE_SIZE_EXT = $80DC;
  GL_COLOR_TABLE_ALPHA_SIZE_EXT = $80DD;
  GL_COLOR_TABLE_LUMINANCE_SIZE_EXT = $80DE;
  GL_COLOR_TABLE_INTENSITY_SIZE_EXT = $80DF;

{ EXT_bgra }

const
  GL_BGR_EXT = $80E0;
  GL_BGRA_EXT = $80E1;

{ EXT_paletted_texture }

const
  GL_COLOR_INDEX1_EXT = $80E2;
  GL_COLOR_INDEX2_EXT = $80E3;
  GL_COLOR_INDEX4_EXT = $80E4;
  GL_COLOR_INDEX8_EXT = $80E5;
  GL_COLOR_INDEX12_EXT = $80E6;
  GL_COLOR_INDEX16_EXT = $80E7;

{ SGI_compiled_vertex_array }

const
  GL_ARRAY_ELEMENT_LOCK_FIRST_SGI = $81A8;
  GL_ARRAY_ELEMENT_LOCK_COUNT_SGI = $81A9;

{ SGI_cull_vertex }

const
  GL_CULL_VERTEX_SGI = $81AA;
  GL_CULL_VERTEX_EYE_POSITION_SGI = $81A;
  GL_CULL_VERTEX_OBJECT_POSITION_SGI = $81AC;

{ SGI_index_array_formats }

const
  GL_IUI_V2F_SGI = $81AD;
  GL_IUI_V3F_SGI = $81AE;
  GL_IUI_N3F_V2F_SGI = $81AF;
  GL_IUI_N3F_V3F_SGI = $81B0;
  GL_T2F_IUI_V2F_SGI = $81B1;
  GL_T2F_IUI_V3F_SGI = $81B2;
  GL_T2F_IUI_N3F_V2F_SGI = $81B3;
  GL_T2F_IUI_N3F_V3F_SGI = $81B4;

{ SGI_index_func }

const
  GL_INDEX_TEST_SGI = $81B5;
  GL_INDEX_TEST_FUNC_SGI = $81B6;
  GL_INDEX_TEST_REF_SGI = $81B7;

{ SGI_index_material }

const
  GL_INDEX_MATERIAL_SGI = $81B8;
  GL_INDEX_MATERIAL_PARAMETER_SGI = $81B9;
  GL_INDEX_MATERIAL_FACE_SGI = $81BA;

{***********************************************************}

type
  TglAccumProc = procedure (op : GLenum; value : GLfloat); stdcall;

  TglAlphaFuncProc = procedure (func : GLenum; ref : GLclampf); stdcall;

  TglAreTexturesResidentProc = function (n : GLsizei;
    {!! const }textures : PGLuint;
    residences : PGLboolean) : GLboolean; stdcall;

  TglArrayElementProc = procedure (i : GLint); stdcall;

  TglBeginProc = procedure (mode : GLenum); stdcall;

  TglBindTextureProc = procedure (target : GLenum; texture : GLuint); stdcall;

  TglBitmapProc = procedure (width : GLsizei; height : GLsizei;
    xorig : GLfloat; yorig : GLfloat; xmove : GLfloat; ymove : GLfloat;
    {!! const } bitmap : PGLubyte); stdcall;

  TglBlendFuncProc = procedure (sfactor : GLenum; dfactor : GLenum); stdcall;

  TglCallListProc = procedure (list : GLuint); stdcall;

  TglCallListsProc = procedure (n : GLsizei; _type : GLenum;
    {!! const } lists : PGLvoid); stdcall;

  TglClearProc = procedure (mask : GLbitfield); stdcall;

  TglClearAccumProc = procedure (red : GLfloat; green : GLfloat;
    blue : GLfloat; alpha : GLfloat); stdcall;

  TglClearColorProc = procedure (red : GLclampf; green : GLclampf;
    blue : GLclampf; alpha : GLclampf); stdcall;

  TglClearDepthProc = procedure (depth : GLclampd); stdcall;

  TglClearIndexProc = procedure (c : GLfloat); stdcall;

  TglClearStencilProc = procedure (s : GLint); stdcall;

  TglClipPlaneProc = procedure (plane : GLenum;
    {!! const } equation : PGLdouble); stdcall;

  TglColor3bProc = procedure (red : GLbyte; green : GLbyte;
    blue : GLbyte); stdcall;

  TglColor3bvProc = procedure ({!! const } v : PGLbyte); stdcall;

  TglColor3dProc = procedure (red : GLdouble; green : GLdouble;
    blue : GLdouble); stdcall;

  TglColor3dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglColor3fProc = procedure (red : GLfloat; green : GLfloat;
    blue : GLfloat); stdcall;

  TglColor3fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglColor3iProc = procedure (red : GLint; green : GLint;
    blue : GLint); stdcall;

  TglColor3ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglColor3sProc = procedure (red : GLshort; green : GLshort;
    blue : GLshort); stdcall;

  TglColor3svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglColor3ubProc = procedure (red : GLubyte; green : GLubyte;
    blue : GLubyte); stdcall;

  TglColor3ubvProc = procedure ({!! const } v : PGLubyte); stdcall;

  TglColor3uiProc = procedure (red : GLuint; green : GLuint;
    blue : GLuint); stdcall;

  TglColor3uivProc = procedure ({!! const } v : PGLuint); stdcall;

  TglColor3usProc = procedure (red : GLushort; green : GLushort;
    blue : GLushort); stdcall;

  TglColor3usvProc = procedure ({!! const } v : PGLushort); stdcall;

  TglColor4bProc = procedure (red : GLbyte; green : GLbyte; blue : GLbyte;
    alpha : GLbyte); stdcall;

  TglColor4bvProc = procedure ({!! const } v : PGLbyte); stdcall;

  TglColor4dProc = procedure (red : GLdouble; green : GLdouble;
    blue : GLdouble; alpha : GLdouble); stdcall;

  TglColor4dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglColor4fProc = procedure (red : GLfloat; green : GLfloat; blue : GLfloat;
    alpha : GLfloat); stdcall;

  TglColor4fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglColor4iProc = procedure (red : GLint; green : GLint; blue : GLint;
    alpha : GLint); stdcall;

  TglColor4ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglColor4sProc = procedure (red : GLshort; green : GLshort; blue : GLshort;
    alpha : GLshort); stdcall;

  TglColor4svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglColor4ubProc = procedure (red : GLubyte; green : GLubyte; blue : GLubyte;
    alpha : GLubyte); stdcall;

  TglColor4ubvProc = procedure ({!! const } v : PGLubyte); stdcall;

  TglColor4uiProc = procedure (red : GLuint; green : GLuint; blue : GLuint;
    alpha : GLuint); stdcall;

  TglColor4uivProc = procedure ({!! const } v : PGLuint); stdcall;

  TglColor4usProc = procedure (red : GLushort; green : GLushort; blue : GLushort;
    alpha : GLushort); stdcall;

  TglColor4usvProc = procedure ({!! const } v : PGLushort); stdcall;

  TglColorMaskProc = procedure (red : GLboolean; green : GLboolean;
    blue : GLboolean; alpha : GLboolean); stdcall;

  TglColorMaterialProc = procedure (face : GLenum; mode : GLenum); stdcall;

  TglColorPointerProc = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  TglCopyPixelsProc = procedure (x : GLint; y : GLint; width : GLsizei;
    height : GLsizei; _type : GLenum); stdcall;

  TglCopyTexImage1DProc = procedure (target : GLenum; level : GLint;
    internalformat : GLenum; x : GLint; y : GLint; width : GLsizei;
    border : GLint); stdcall;

  TglCopyTexImage2DProc = procedure (target : GLenum; level : GLint;
    internalformat : GLenum; x : GLint; y : GLint; width : GLsizei;
    height : GLsizei; border : GLint); stdcall;

  TglCopyTexSubImage1DProc = procedure (target : GLenum; level : GLint;
    xoffset : GLint; x : GLint; y : GLint; width : GLsizei); stdcall;

  TglCopyTexSubImage2DProc = procedure (target : GLenum; level : GLint;
    xoffset : GLint; yoffset : GLint; x : GLint; y : GLint; width : GLsizei;
    height : GLsizei); stdcall;

  TglCullFaceProc = procedure (mode : GLenum); stdcall;

  TglDeleteListsProc = procedure (list : GLuint; range : GLsizei); stdcall;

  TglDeleteTexturesProc = procedure (n : GLsizei;
    {!! const } textures : PGLuint); stdcall;

  TglDepthFuncProc = procedure (func : GLenum); stdcall;

  TglDepthMaskProc = procedure (flag : GLboolean); stdcall;

  TglDepthRangeProc = procedure (zNear : GLclampd; zFar : GLclampd); stdcall;

  TglDisableProc = procedure (cap : GLenum); stdcall;

  TglDisableClientStateProc = procedure (_array : GLenum); stdcall;

  TglDrawArraysProc = procedure (mode : GLenum; first : GLint;
    count : GLsizei); stdcall;

  TglDrawBufferProc = procedure (mode : GLenum); stdcall;

  TglDrawElementsProc = procedure (mode : GLenum; count : GLsizei;
    _type : GLenum; {!! const } indices : PGLvoid); stdcall;

  TglDrawPixelsProc = procedure (width : GLsizei; height : GLsizei;
    format : GLenum; _type : GLenum; {!! const } pixels : PGLvoid); stdcall;

  TglEdgeFlagProc = procedure (flag : GLboolean); stdcall;

  TglEdgeFlagPointerProc = procedure (stride : GLsizei;
    {!! const } pointer : GLboolean); stdcall;

  TglEdgeFlagvProc = procedure ({!! const } flag : PGLboolean); stdcall;

  TglEnableProc = procedure (cap : GLenum); stdcall;

  TglEnableClientStateProc = procedure (_array : GLenum); stdcall;

  TglEndProc = procedure; stdcall;

  TglEndListProc = procedure; stdcall;

  TglEvalCoord1dProc = procedure (u : GLdouble); stdcall;

  TglEvalCoord1dvProc = procedure ({!! const } u : PGLdouble); stdcall;

  TglEvalCoord1fProc = procedure (u : GLfloat); stdcall;

  TglEvalCoord1fvProc = procedure ({!! const } u : PGLfloat); stdcall;

  TglEvalCoord2dProc = procedure (u : GLdouble; v : GLdouble); stdcall;

  TglEvalCoord2dvProc = procedure ({!! const } u : PGLdouble); stdcall;

  TglEvalCoord2fProc = procedure (u : GLfloat; v : GLfloat); stdcall;

  TglEvalCoord2fvProc = procedure ({!! const } u : PGLfloat); stdcall;

  TglEvalMesh1Proc = procedure (mode : GLenum; i1 : GLint;
    i2 : GLint); stdcall;

  TglEvalMesh2Proc = procedure (mode : GLenum; i1 : GLint; i2 : GLint;
    j1 : GLint; j2 : GLint); stdcall;

  TglEvalPoint1Proc = procedure (i : GLint); stdcall;

  TglEvalPoint2Proc = procedure (i : GLint; j : GLint); stdcall;

  TglFeedbackBufferProc = procedure (size : GLsizei; _type : GLenum;
    buffer : PGLfloat); stdcall;

  TglFinishProc = procedure; stdcall;

  TglFlushProc = procedure; stdcall;

  TglFogfProc = procedure (pname : GLenum; param : GLfloat); stdcall;

  TglFogfvProc = procedure (pname : GLenum;
    {!! const }params : PGLfloat); stdcall;

  TglFogiProc = procedure (pname : GLenum; param : GLint); stdcall;

  TglFogivProc = procedure (pname : GLenum;
    {!! const }params : PGLint); stdcall;

  TglFrontFaceProc = procedure (mode : GLenum); stdcall;

  TglFrustumProc = procedure (left : GLdouble; right : GLdouble;
    bottom : GLdouble; top : GLdouble; zNear : GLdouble;
    zFar : GLdouble); stdcall;

  TglGenListsProc = function (range : GLsizei) : GLuint; stdcall;

  TglGenTexturesProc = procedure (n : GLsizei; textures : PGLuint); stdcall;

  TglGetBooleanvProc = procedure (pname : GLenum;
    params : PGLboolean); stdcall;

  TglGetClipPlaneProc = procedure (plane : GLenum;
    equation : PGLdouble); stdcall;

  TglGetDoublevProc = procedure (pname : GLenum; params : PGLdouble); stdcall;

  TglGetErrorProc = function : GLenum; stdcall;

  TglGetFloatvProc = procedure (pname : GLenum; params : PGLfloat); stdcall;

  TglGetIntegervProc = procedure (pname : GLenum; params : PGLint); stdcall;

  TglGetLightfvProc = procedure (light : GLenum; pname : GLenum;
    params : PGLfloat); stdcall;

  TglGetLightivProc = procedure (light : GLenum; pname : GLenum;
    params : PGLint); stdcall;

  TglGetMapdvProc = procedure (target : GLenum; query : GLenum;
    v : PGLdouble); stdcall;

  TglGetMapfvProc = procedure (target : GLenum; query : GLenum;
    v : PGLfloat); stdcall;

  TglGetMapivProc = procedure (target : GLenum; query : GLenum;
    v : PGLint); stdcall;

  TglGetMaterialfvProc = procedure (face : GLenum; pname : GLenum;
    params : PGLfloat); stdcall;

  TglGetMaterialivProc = procedure (face : GLenum; pname : GLenum;
    params : PGLint); stdcall;

  TglGetPixelMapfvProc = procedure (map : GLenum; values : PGLfloat); stdcall;

  TglGetPixelMapuivProc = procedure (map : GLenum; values : PGLuint); stdcall;

  TglGetPixelMapusvProc = procedure (map : GLenum;
    values : PGLushort); stdcall;

  TglGetPointervProc = procedure (pname : GLenum; params : PPGLvoid); stdcall;

  TglGetPolygonStippleProc = procedure (mask : PGLubyte); stdcall;

  TglGetStringProc = function (name : GLenum) : PGLubyte; stdcall;

  TglGetTexEnvfvProc = procedure (target : GLenum; pname : GLenum;
    params : PGLfloat); stdcall;

  TglGetTexEnvivProc = procedure (target : GLenum; pname : GLenum;
    params : PGLint); stdcall;

  TglGetTexGendvProc = procedure (coord : GLenum; pname : GLenum;
    params : PGLdouble); stdcall;

  TglGetTexGenfvProc = procedure (coord : GLenum; pname : GLenum;
    params : PGLfloat); stdcall;

  TglGetTexGenivProc = procedure (coord : GLenum; pname : GLenum;
    params : PGLint); stdcall;

  TglGetTexImageProc = procedure (target : GLenum; level : GLint;
    format : GLenum; _type : GLenum; pixels : PGLvoid); stdcall;

  TglGetTexLevelParameterfvProc = procedure (target : GLenum; level : GLint;
    pname : GLenum; params : PGLfloat); stdcall;

  TglGetTexLevelParameterivProc = procedure (target : GLenum; level : GLint;
    pname : GLenum; params : PGLint); stdcall;

  TglGetTexParameterfvProc = procedure (target : GLenum; pname : GLenum;
    params : PGLfloat); stdcall;

  TglGetTexParameterivProc = procedure (target : GLenum; pname : GLenum;
    params : PGLint); stdcall;

  TglHintProc = procedure (target : GLenum; mode : GLenum); stdcall;

  TglIndexMaskProc = procedure (mask : GLuint); stdcall;

  TglIndexPointerProc = procedure (_type : GLenum; stride : GLsizei;
    {!! const } pointer : PGLvoid); stdcall;

  TglIndexdProc = procedure (c : GLdouble); stdcall;

  TglIndexdvProc = procedure ({!! const } c : PGLdouble); stdcall;

  TglIndexfProc = procedure (c : GLfloat); stdcall;

  TglIndexfvProc = procedure ({!! const } c : PGLfloat); stdcall;

  TglIndexiProc = procedure (c : GLint); stdcall;

  TglIndexivProc = procedure ({!! const } c : PGLint); stdcall;

  TglIndexsProc = procedure (c : GLshort); stdcall;

  TglIndexsvProc = procedure ({!! const } c : PGLshort); stdcall;

  TglIndexubProc = procedure (c : GLubyte); stdcall;

  TglIndexubvProc = procedure ({!! const } c : PGLubyte); stdcall;

  TglInitNamesProc = procedure; stdcall;

  TglInterleavedArraysProc = procedure (format : GLenum; stride : GLsizei;
    {!! const }pointer : PGLvoid); stdcall;

  TglIsEnabledProc = function (cap : GLenum) : GLboolean; stdcall;

  TglIsListProc = function (list : GLuint) : GLboolean; stdcall;

  TglIsTextureProc = function (texture : GLuint) : GLboolean; stdcall;

  TglLightModelfProc = procedure (pname : GLenum; param : GLfloat); stdcall;

  TglLightModelfvProc = procedure (pname : GLenum;
    {!! const } params : PGLfloat); stdcall;

  TglLightModeliProc = procedure (pname : GLenum; param : GLint); stdcall;

  TglLightModelivProc = procedure (pname : GLenum;
    {!! const } params : PGLint); stdcall;

  TglLightfProc = procedure (light : GLenum; pname : GLenum;
    param : GLfloat); stdcall;

  TglLightfvProc = procedure (light : GLenum; pname : GLenum;
    {!! const } params : PGLfloat); stdcall;

  TglLightiProc = procedure (light : GLenum; pname : GLenum;
    param : GLint); stdcall;

  TglLightivProc = procedure (light : GLenum; pname : GLenum;
    {!! const }params : PGLint); stdcall;

  TglLineStippleProc = procedure (factor : GLint; pattern : GLushort); stdcall;

  TglLineWidthProc = procedure (width : GLfloat); stdcall;

  TglListBaseProc = procedure (base : GLuint); stdcall;

  TglLoadIdentityProc = procedure; stdcall;

  TglLoadMatrixdProc = procedure ({!! const } m : PGLdouble); stdcall;

  TglLoadMatrixfProc = procedure ({!! const } m : PGLfloat); stdcall;

  TglLoadNameProc = procedure (name : GLuint); stdcall;

  TglLogicOpProc = procedure (opcode : GLenum); stdcall;

  TglMap1dProc = procedure (target : GLenum; u1 : GLdouble; u2 : GLdouble;
  stride : GLint; order : GLint; {!! const }points : PGLdouble); stdcall;

  TglMap1fProc = procedure (target : GLenum; u1 : GLfloat; u2 : GLfloat;
    stride : GLint; order : GLint; {!! const }points : PGLfloat); stdcall;

  TglMap2dProc = procedure (target : GLenum; u1 : GLdouble; u2 : GLdouble;
    ustride : GLint; uorder : GLint; v1 : GLdouble; v2 : GLdouble;
    vstride : GLint; vorder : GLint; points : PGLdouble); stdcall;

  TglMap2fProc = procedure (target : GLenum; u1 : GLfloat; u2 : GLfloat;
    ustride : GLint; uorder : GLint; v1 : GLfloat; v2 : GLfloat;
    vstride : GLint; vorder : GLint; {!! const }points : PGLfloat); stdcall;

  TglMapGrid1dProc = procedure (un : GLint; u1 : GLdouble;
    u2 : GLdouble); stdcall;

  TglMapGrid1fProc = procedure (un : GLint; u1 : GLfloat;
    u2 : GLfloat); stdcall;

  TglMapGrid2dProc = procedure (un : GLint; u1 : GLdouble; u2 : GLdouble;
    vn : GLint; v1 : GLdouble; v2 : GLdouble); stdcall;

  TglMapGrid2fProc = procedure (un : GLint; u1 : GLfloat; u2 : GLfloat;
    vn : GLint; v1 : GLfloat; v2 : GLfloat); stdcall;

  TglMaterialfProc = procedure (face : GLenum; pname : GLenum;
    param : GLfloat); stdcall;

  TglMaterialfvProc = procedure (face : GLenum; pname : GLenum;
  {!! const } params : PGLfloat); stdcall;

  TglMaterialiProc = procedure (face : GLenum; pname : GLenum;
    param : GLint); stdcall;

  TglMaterialivProc = procedure (face : GLenum; pname : GLenum;
    {!! const } params : PGLint); stdcall;

  TglMatrixModeProc = procedure (mode : GLenum); stdcall;

  TglMultMatrixdProc = procedure ({!! const } m : PGLdouble); stdcall;

  TglMultMatrixfProc = procedure ({!! const } m : PGLfloat); stdcall;

  TglNewListProc = procedure (list : GLuint; mode : GLenum); stdcall;

  TglNormal3bProc = procedure (nx : GLbyte; ny : GLbyte; nz : GLbyte); stdcall;

  TglNormal3bvProc = procedure ({!! const } v : PGLbyte); stdcall;

  TglNormal3dProc = procedure (nx : GLdouble; ny : GLdouble;
    nz : GLdouble); stdcall;

  TglNormal3dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglNormal3fProc = procedure (nx : GLfloat; ny : GLfloat;
    nz : GLfloat); stdcall;

  TglNormal3fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglNormal3iProc = procedure (nx : GLint; ny : GLint; nz : GLint); stdcall;

  TglNormal3ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglNormal3sProc = procedure (nx : GLshort; ny : GLshort;
    nz : GLshort); stdcall;

  TglNormal3svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglNormalPointerProc = procedure (_type : GLenum; stride : GLsizei;
    {!! const } pointer : PGLvoid); stdcall;

  TglOrthoProc = procedure (left : GLdouble; right : GLdouble;
    bottom : GLdouble; top : GLdouble; zNear : GLdouble;
    zFar : GLdouble); stdcall;

  TglPassThroughProc = procedure (token : GLfloat); stdcall;

  TglPixelMapfvProc = procedure (map : GLenum; mapsize : GLint;
    {!! const } values : PGLfloat); stdcall;

  TglPixelMapuivProc = procedure (map : GLenum; mapsize : GLint;
    {!! const } values : PGLuint); stdcall;

  TglPixelMapusvProc = procedure (map : GLenum; mapsize : GLint;
    {!! const } values : PGLushort); stdcall;

  TglPixelStorefProc = procedure (pname : GLenum; param : GLfloat); stdcall;

  TglPixelStoreiProc = procedure (pname : GLenum; param : GLint); stdcall;

  TglPixelTransferfProc = procedure (pname : GLenum; param : GLfloat); stdcall;

  TglPixelTransferiProc = procedure (pname : GLenum; param : GLint); stdcall;

  TglPixelZoomProc = procedure (xfactor : GLfloat; yfactor : GLfloat); stdcall;

  TglPointSizeProc = procedure (size : GLfloat); stdcall;

  TglPolygonModeProc = procedure (face : GLenum; mode : GLenum); stdcall;

  TglPolygonOffsetProc = procedure (factor : GLfloat;
    units : GLfloat); stdcall;

  TglPolygonStippleProc = procedure ({!! const } mask : PGLubyte); stdcall;

  TglPopAttribProc = procedure; stdcall;

  TglPopClientAttribProc = procedure; stdcall;

  TglPopMatrixProc = procedure; stdcall;

  TglPopNameProc = procedure; stdcall;

  TglPrioritizeTexturesProc = procedure (n : GLsizei;
    {!! const } textures : PGLuint;
    {!! const } priorities : PGLclampf); stdcall;

  TglPushAttribProc = procedure (mask : GLbitfield); stdcall;

  TglPushClientAttribProc = procedure (mask : GLbitfield); stdcall;

  TglPushMatrixProc = procedure; stdcall;

  TglPushNameProc = procedure (name : GLuint); stdcall;

  TglRasterPos2dProc = procedure (x : GLdouble; y : GLdouble); stdcall;

  TglRasterPos2dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglRasterPos2fProc = procedure (x : GLfloat; y : GLfloat); stdcall;

  TglRasterPos2fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglRasterPos2iProc = procedure (x : GLint; y : GLint); stdcall;

  TglRasterPos2ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglRasterPos2sProc = procedure (x : GLshort; y : GLshort); stdcall;

  TglRasterPos2svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglRasterPos3dProc = procedure (x : GLdouble; y : GLdouble;
    z : GLdouble); stdcall;

  TglRasterPos3dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglRasterPos3fProc = procedure (x : GLfloat; y : GLfloat;
    z : GLfloat); stdcall;

  TglRasterPos3fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglRasterPos3iProc = procedure (x : GLint; y : GLint; z : GLint); stdcall;

  TglRasterPos3ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglRasterPos3sProc = procedure (x : GLshort; y : GLshort;
    z : GLshort); stdcall;

  TglRasterPos3svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglRasterPos4dProc = procedure (x : GLdouble; y : GLdouble; z : GLdouble;
    w : GLdouble); stdcall;

  TglRasterPos4dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglRasterPos4fProc = procedure (x : GLfloat; y : GLfloat; z : GLfloat;
    w : GLfloat); stdcall;

  TglRasterPos4fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglRasterPos4iProc = procedure (x : GLint; y : GLint; z : GLint;
    w : GLint); stdcall;

  TglRasterPos4ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglRasterPos4sProc = procedure (x : GLshort; y : GLshort; z : GLshort;
    w : GLshort); stdcall;

  TglRasterPos4svProc = procedure (v : PGLshort); stdcall;

  TglReadBufferProc = procedure (mode : GLenum); stdcall;

  TglReadPixelsProc = procedure (x : GLint; y : GLint; width : GLsizei;
    height : GLsizei; format : GLenum; _type : GLenum;
    pixels : PGLvoid); stdcall;

  TglRectdProc = procedure (x1 : GLdouble; y1 : GLdouble; x2 : GLdouble;
    y2 : GLdouble); stdcall;

  TglRectdvProc = procedure ({!! const } v1 : PGLdouble;
    {!! const } v2 : PGLdouble); stdcall;

  TglRectfProc = procedure (x1 : GLfloat; y1 : GLfloat; x2 : GLfloat;
    y2 : GLfloat); stdcall;

  TglRectfvProc = procedure ({!! const } v1 : PGLfloat;
    {!! const } v2 : PGLfloat); stdcall;

  TglRectiProc = procedure (x1 : GLint; y1 : GLint; x2 : GLint;
    y2 : GLint); stdcall;

  TglRectivProc = procedure ({!! const } v1 : PGLint;
    {!! const } v2 : PGLint); stdcall;

  TglRectsProc = procedure (x1 : GLshort; y1 : GLshort; x2 : GLshort;
    y2 : GLshort); stdcall;

  TglRectsvProc = procedure ({!! const } v1 : PGLshort;
    {!! const } v2 : PGLshort); stdcall;

  TglRenderModeProc = function (mode : GLenum) : GLint; stdcall;

  TglRotatedProc = procedure (angle : GLdouble; x : GLdouble; y : GLdouble;
    z : GLdouble); stdcall;

  TglRotatefProc = procedure (angle : GLfloat; x : GLfloat; y : GLfloat;
    z : GLfloat); stdcall;

  TglScaledProc = procedure (x : GLdouble; y : GLdouble;
    z : GLdouble); stdcall;

  TglScalefProc = procedure (x : GLfloat; y : GLfloat; z : GLfloat); stdcall;

  TglScissorProc = procedure (x : GLint; y : GLint; width : GLsizei;
    height : GLsizei); stdcall;

  TglSelectBufferProc = procedure (size : GLsizei; buffer : PGLuint); stdcall;

  TglShadeModelProc = procedure (mode : GLenum); stdcall;

  TglStencilFuncProc = procedure (func : GLenum; ref : GLint;
    mask : GLuint); stdcall;

  TglStencilMaskProc = procedure (mask : GLuint); stdcall;

  TglStencilOpProc = procedure (fail : GLenum; zfail : GLenum;
    zpass : GLenum); stdcall;

  TglTexCoord1dProc = procedure (s : GLdouble); stdcall;

  TglTexCoord1dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglTexCoord1fProc = procedure (s : GLfloat); stdcall;

  TglTexCoord1fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglTexCoord1iProc = procedure (s : GLint); stdcall;

  TglTexCoord1ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglTexCoord1sProc = procedure (s : GLshort); stdcall;

  TglTexCoord1svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglTexCoord2dProc = procedure (s : GLdouble; t : GLdouble); stdcall;

  TglTexCoord2dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglTexCoord2fProc = procedure (s : GLfloat; t : GLfloat); stdcall;

  TglTexCoord2fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglTexCoord2iProc = procedure (s : GLint; t : GLint); stdcall;

  TglTexCoord2ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglTexCoord2sProc = procedure (s : GLshort; t : GLshort); stdcall;

  TglTexCoord2svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglTexCoord3dProc = procedure (s : GLdouble; t : GLdouble;
    r : GLdouble); stdcall;

  TglTexCoord3dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglTexCoord3fProc = procedure (s : GLfloat; t : GLfloat;
    r : GLfloat); stdcall;

  TglTexCoord3fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglTexCoord3iProc = procedure (s : GLint; t : GLint; r : GLint); stdcall;

  TglTexCoord3ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglTexCoord3sProc = procedure (s : GLshort; t : GLshort;
    r : GLshort); stdcall;

  TglTexCoord3svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglTexCoord4dProc = procedure (s : GLdouble; t : GLdouble; r : GLdouble;
    q : GLdouble); stdcall;

  TglTexCoord4dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglTexCoord4fProc = procedure (s : GLfloat; t : GLfloat; r : GLfloat;
    q : GLfloat); stdcall;

  TglTexCoord4fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglTexCoord4iProc = procedure (s : GLint; t : GLint; r : GLint;
    q : GLint); stdcall;

  TglTexCoord4ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglTexCoord4sProc = procedure (s : GLshort; t : GLshort; r : GLshort;
    q : GLshort); stdcall;

  TglTexCoord4svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglTexCoordPointerProc = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  TglTexEnvfProc = procedure (target : GLenum; pname : GLenum;
    param : GLfloat); stdcall;

  TglTexEnvfvProc = procedure (target : GLenum; pname : GLenum;
    {!! const } params : PGLfloat); stdcall;

  TglTexEnviProc = procedure (target : GLenum; pname : GLenum;
    param : GLint); stdcall;

  TglTexEnvivProc = procedure (target : GLenum; pname : GLenum;
    {!! const } params : PGLint); stdcall;

  TglTexGendProc = procedure (coord : GLenum; pname : GLenum;
    param : GLdouble); stdcall;

  TglTexGendvProc = procedure (coord : GLenum; pname : GLenum;
    {!! const } params : PGLdouble); stdcall;

  TglTexGenfProc = procedure (coord : GLenum; pname : GLenum;
    param : GLfloat); stdcall;

  TglTexGenfvProc = procedure (coord : GLenum; pname : GLenum;
    {!! const } params : PGLfloat); stdcall;

  TglTexGeniProc = procedure (coord : GLenum; pname : GLenum;
    param : GLint); stdcall;

  TglTexGenivProc = procedure (coord : GLenum; pname : GLenum;
    {!! const } params : PGLint); stdcall;

  TglTexImage1DProc = procedure (target : GLenum; level : GLint;
    components : GLint; width : GLsizei; border : GLint; format : GLenum;
    _type : GLenum; {!! const } pixels : PGLvoid); stdcall;

  TglTexImage2DProc = procedure (target : GLenum; level : GLint;
    components : GLint; width : GLsizei; height : GLsizei; border : GLint;
    format : GLenum; _type : GLenum; {!! const } pixels : PGLvoid); stdcall;

  TglTexParameterfProc = procedure (target : GLenum; pname : GLenum;
    param : GLfloat); stdcall;

  TglTexParameterfvProc = procedure (target : GLenum; pname : GLenum;
    {!! const } params : PGLfloat); stdcall;

  TglTexParameteriProc = procedure (target : GLenum; pname : GLenum;
    param : GLint); stdcall;

  TglTexParameterivProc = procedure (target : GLenum; pname : GLenum;
    {!! const } params : PGLint); stdcall;

  TglTexSubImage1DProc = procedure (target : GLenum; level : GLint;
    xoffset : GLint; width : GLsizei; format : GLenum; _type : GLenum;
    {!! const } pixels : PGLvoid); stdcall;

  TglTexSubImage2DProc = procedure (target : GLenum; level : GLint;
    xoffset : GLint; yoffset : GLint; width : GLsizei; height : GLsizei;
    format : GLenum; _type : GLenum; {!! const } pixels : PGLvoid); stdcall;

  TglTranslatedProc = procedure (x : GLdouble; y : GLdouble;
    z : GLdouble); stdcall;

  TglTranslatefProc = procedure (x : GLfloat; y : GLfloat;
    z : GLfloat); stdcall;

  TglVertex2dProc = procedure (x : GLdouble; y : GLdouble); stdcall;

  TglVertex2dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglVertex2fProc = procedure (x : GLfloat; y : GLfloat); stdcall;

  TglVertex2fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglVertex2iProc = procedure (x : GLint; y : GLint); stdcall;

  TglVertex2ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglVertex2sProc = procedure (x : GLshort; y : GLshort); stdcall;

  TglVertex2svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglVertex3dProc = procedure (x : GLdouble; y : GLdouble;
    z : GLdouble); stdcall;

  TglVertex3dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglVertex3fProc = procedure (x : GLfloat; y : GLfloat;
    z : GLfloat); stdcall;

  TglVertex3fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglVertex3iProc = procedure (x : GLint; y : GLint; z : GLint); stdcall;

  TglVertex3ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglVertex3sProc = procedure (x : GLshort; y : GLshort; z : GLshort); stdcall;

  TglVertex3svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglVertex4dProc = procedure (x : GLdouble; y : GLdouble; z : GLdouble;
    w : GLdouble); stdcall;

  TglVertex4dvProc = procedure ({!! const } v : PGLdouble); stdcall;

  TglVertex4fProc = procedure (x : GLfloat; y : GLfloat; z : GLfloat;
    w : GLfloat); stdcall;

  TglVertex4fvProc = procedure ({!! const } v : PGLfloat); stdcall;

  TglVertex4iProc = procedure (x : GLint; y : GLint; z : GLint;
    w : GLint); stdcall;

  TglVertex4ivProc = procedure ({!! const } v : PGLint); stdcall;

  TglVertex4sProc = procedure (x : GLshort; y : GLshort; z : GLshort;
    w : GLshort); stdcall;

  TglVertex4svProc = procedure ({!! const } v : PGLshort); stdcall;

  TglVertexPointerProc = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  TglViewportProc = procedure (x : GLint; y : GLint; width : GLsizei;
    height : GLsizei); stdcall;

  TwglCopyContextProc = function (p1 : HGLRC; p2 : HGLRC;
    p3 : Cardinal) : BOOL; stdcall;

  TwglCreateContextProc = function (DC : HDC) : HGLRC; stdcall;

  TwglCreateLayerContextProc = function (p1 : HDC;
    p2 : Integer) : HGLRC; stdcall;

  TwglDeleteContextProc = function (p1 : HGLRC) : BOOL; stdcall;

  TwglGetCurrentContext = function : HGLRC; stdcall;

  TwglGetCurrentDC = function : HDC; stdcall;

  TwglMakeCurrentProc = function (DC : HDC; p2 : HGLRC) : BOOL; stdcall;

  TwglShareListsProc = function (p1, p2 : HGLRC) : BOOL; stdcall;

  TwglUseFontBitmapsAProc = function (DC : HDC;
    p2, p3, p4 : DWORD) : BOOL; stdcall;

  TwglUseFontBitmapsWProc = function (DC : HDC;
    p2, p3, p4 : DWORD) : BOOL; stdcall;

  TwglUseFontBitmapsProc = function (DC : HDC;
    p2, p3, p4 : DWORD) : BOOL; stdcall;

  TSwapBuffersProc = function (DC : HDC) : BOOL; stdcall;

  TwglUseFontOutlinesAProc = function (p1 : HDC; p2, p3, p4 : DWORD;
    p5, p6 : Single; p7 : Integer; p8 : PGlyphMetricsFloat) : BOOL; stdcall;

  TwglUseFontOutlinesWProc = function (p1 : HDC; p2, p3, p4 : DWORD;
    p5, p6 : Single; p7 : Integer; p8 : PGlyphMetricsFloat) : BOOL; stdcall;

  TwglUseFontOutlinesProc = function (p1 : HDC; p2, p3, p4 : DWORD;
    p5, p6 : Single; p7 : Integer; p8 : PGlyphMetricsFloat) : BOOL; stdcall;

  TwglDescribeLayerPlaneProc = function (p1 : HDC; p2, p3 : Integer;
    p4 : Cardinal; var p5 : TLayerPlaneDescriptor) : BOOL; stdcall;

  TwglSetLayerPaletteEntriesProc = function (p1 : HDC; p2, p3, p4 : Integer;
    var pcr) : Integer; stdcall;

  TwglGetLayerPaletteEntriesProc = function (p1 : HDC; p2, p3, p4 : Integer;
    var pcr) : Integer; stdcall;

  TwglRealizeLayerPaletteProc = function (p1 : HDC; p2 : Integer;
    p3 : BOOL) : BOOL; stdcall;

  TwglSwapLayerBuffersProc = function (p1 : HDC;
    p2 : Cardinal) : BOOL; stdcall;

  TChoosePixelFormatPRoc = function (DC : HDC;
    p2 : PPixelFormatDescriptor) : Integer; stdcall;

  TGetPixelFormatProc = function (DC : HDC) : Integer; stdcall;

  TSetPixelFormatProc = function (DC : HDC; p2 : Integer;
    p3 : PPixelFormatDescriptor) : BOOL; stdcall;

  TDescribePixelFormatProc = function (DC : HDC; p2 : Integer; p3 : UINT;
    var p4 : TPixelFormatDescriptor) : BOOL; stdcall;

{ EXT_vertex_array }

type
  PFNGLARRAYELEMENTEXTPROC = procedure (i : GLint); stdcall;

  PFNGLCOLORPOINTEREXTPROC = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; count : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  PFNGLDRAWARRAYSEXTPROC = procedure (mode : GLenum; first : GLint;
    count : GLsizei); stdcall;

  PFNGLEDGEFLAGPOINTEREXTPROC = procedure (stride : GLsizei; count : GLsizei;
    {!! const } pointer : PGLboolean); stdcall;

  PFNGLGETPOINTERVEXTPROC = procedure (pname : GLenum;
    params : PPGLvoid); stdcall;

  PFNGLINDEXPOINTEREXTPROC = procedure (_type : GLenum; stride : GLsizei;
    count : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  PFNGLNORMALPOINTEREXTPROC = procedure (_type : GLenum; stride : GLsizei;
    count : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  PFNGLTEXCOORDPOINTEREXTPROC = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; count : GLsizei; {!! const } pointer : PGLvoid); stdcall;

  PFNGLVERTEXPOINTEREXTPROC = procedure (size : GLint; _type : GLenum;
    stride : GLsizei; count : GLsizei; {!! const } pointer : PGLvoid); stdcall;

{ EXT_color_subtable }

  PFNGLCOLORSUBTABLEEXTPROC = procedure (target : GLenum; start : GLsizei;
    count : GLsizei; format : GLenum; _type : GLenum;
    table : PGLvoid); stdcall;

{ EXT_color_table }

  PFNGLCOLORTABLEEXTPROC = procedure (target : GLenum; internalformat : GLenum;
    width : GLsizei; format : GLenum; _type : GLenum;
    table : PGLvoid); stdcall;

  PFNGLCOPYCOLORTABLEEXTPROC = procedure (target : GLenum;
    internalformat : GLenum; x : GLint; y : GLint; width : GLsizei); stdcall;

  PFNGLGETCOLORTABLEEXTPROC = procedure (target : GLenum; format : GLenum;
    _type : GLenum; table : PGLvoid); stdcall;

  PFNGLGETCOLORTABLEPARAMETERFVEXTPROC = procedure (target : GLenum;
    pname : GLenum; params : PGLfloat); stdcall;

  PFNGLGETCOLORTABLEPARAMETERIVEXTPROC = procedure (target : GLenum;
    pname : GLenum; params : PGLint); stdcall;

{ SGI_compiled_vertex_array }

  PFNGLLOCKARRAYSSGIPROC = procedure (first : GLint; count : GLsizei); stdcall;

  PFNGLUNLOCKARRAYSSGIPROC = procedure; stdcall;

{ SGI_cull_vertex }

  PFNGLCULLPARAMETERDVSGIPROC = procedure (pname : GLenum;
    params : PGLdouble); stdcall;

  PFNGLCULLPARAMETERFVSGIPROC = procedure (pname : GLenum;
    params : PGLfloat); stdcall;

{ SGI_index_func }

  PFNGLINDEXFUNCSGIPROC = procedure (func : GLenum; ref : GLclampf); stdcall;

{ SGI_index_material }

  PFNGLINDEXMATERIALSGIPROC = procedure (face : GLenum;
    mode : GLenum); stdcall;

{ WIN_swap_hint }

  PFNGLADDSWAPHINTRECTWINPROC = procedure (x : GLint; y : GLint;
    width : GLsizei; height : GLsizei); stdcall;

{!! Function variables }

var
  glAccum : TglAccumProc;
  glAlphaFunc : TglAlphaFuncProc;
  glAreTexturesResident : TglAreTexturesResidentProc;
  glArrayElement : TglArrayElementProc;
  glBegin : TglBeginProc;
  glBindTexture : TglBindTextureProc;
  glBitmap : TglBitmapProc;
  glBlendFunc : TglBlendFuncProc;
  glCallList : TglCallListProc;
  glCallLists : TglCallListsProc;
  glClear : TglClearProc;
  glClearAccum : TglClearAccumProc;
  glClearColor : TglClearColorProc;
  glClearDepth : TglClearDepthProc;
  glClearIndex : TglClearIndexProc;
  glClearStencil : TglClearStencilProc;
  glClipPlane : TglClipPlaneProc;
  glColor3b : TglColor3bProc;
  glColor3bv : TglColor3bvProc;
  glColor3d : TglColor3dProc;
  glColor3dv : TglColor3dvProc;
  glColor3f : TglColor3fProc;
  glColor3fv : TglColor3fvProc;
  glColor3i : TglColor3iProc;
  glColor3iv : TglColor3ivProc;
  glColor3s : TglColor3sProc;
  glColor3sv : TglColor3svProc;
  glColor3ub : TglColor3ubProc;
  glColor3ubv : TglColor3ubvProc;
  glColor3ui : TglColor3uiProc;
  glColor3uiv : TglColor3uivProc;
  glColor3us : TglColor3usProc;
  glColor3usv : TglColor3usvProc;
  glColor4b : TglColor4bProc;
  glColor4bv : TglColor4bvProc;
  glColor4d : TglColor4dProc;
  glColor4dv : TglColor4dvProc;
  glColor4f : TglColor4fProc;
  glColor4fv : TglColor4fvProc;
  glColor4i : TglColor4iProc;
  glColor4iv : TglColor4ivProc;
  glColor4s : TglColor4sProc;
  glColor4sv : TglColor4svProc;
  glColor4ub : TglColor4ubProc;
  glColor4ubv : TglColor4ubvProc;
  glColor4ui : TglColor4uiProc;
  glColor4uiv : TglColor4uivProc;
  glColor4us : TglColor4usProc;
  glColor4usv : TglColor4usvProc;
  glColorMask : TglColorMaskProc;
  glColorMaterial : TglColorMaterialProc;
  glColorPointer : TglColorPointerProc;
  glCopyPixels : TglCopyPixelsProc;
  glCopyTexImage1D : TglCopyTexImage1DProc;
  glCopyTexImage2D : TglCopyTexImage2DProc;
  glCopyTexSubImage1D : TglCopyTexSubImage1DProc;
  glCopyTexSubImage2D : TglCopyTexSubImage2DProc;
  glCullFace : TglCullFaceProc;
  glDeleteLists : TglDeleteListsProc;
  glDeleteTextures : TglDeleteTexturesProc;
  glDepthFunc : TglDepthFuncProc;
  glDepthMask : TglDepthMaskProc;
  glDepthRange : TglDepthRangeProc;
  glDisable : TglDisableProc;
  glDisableClientState : TglDisableClientStateProc;
  glDrawArrays : TglDrawArraysProc;
  glDrawBuffer : TglDrawBufferProc;
  glDrawElements : TglDrawElementsProc;
  glDrawPixels : TglDrawPixelsProc;
  glEdgeFlag : TglEdgeFlagProc;
  glEdgeFlagPointer : TglEdgeFlagPointerProc;
  glEdgeFlagv : TglEdgeFlagvProc;
  glEnable : TglEnableProc;
  glEnableClientState : TglEnableClientStateProc;
  glEnd : TglEndProc;
  glEndList : TglEndListProc;
  glEvalCoord1d : TglEvalCoord1dProc;
  glEvalCoord1dv : TglEvalCoord1dvProc;
  glEvalCoord1f : TglEvalCoord1fProc;
  glEvalCoord1fv : TglEvalCoord1fvProc;
  glEvalCoord2d : TglEvalCoord2dProc;
  glEvalCoord2dv : TglEvalCoord2dvProc;
  glEvalCoord2f : TglEvalCoord2fProc;
  glEvalCoord2fv : TglEvalCoord2fvProc;
  glEvalMesh1 : TglEvalMesh1Proc;
  glEvalMesh2 : TglEvalMesh2Proc;
  glEvalPoint1 : TglEvalPoint1Proc;
  glEvalPoint2 : TglEvalPoint2Proc;
  glFeedbackBuffer : TglFeedbackBufferProc;
  glFinish : TglFinishProc;
  glFlush : TglFlushProc;
  glFogf : TglFogfProc;
  glFogfv : TglFogfvProc;
  glFogi : TglFogiProc;
  glFogiv : TglFogivProc;
  glFrontFace : TglFrontFaceProc;
  glFrustum : TglFrustumProc;
  glGenLists : TglGenListsProc;
  glGenTextures : TglGenTexturesProc;
  glGetBooleanv : TglGetBooleanvProc;
  glGetClipPlane : TglGetClipPlaneProc;
  glGetDoublev : TglGetDoublevProc;
  glGetError : TglGetErrorProc;
  glGetFloatv : TglGetFloatvProc;
  glGetIntegerv : TglGetIntegervProc;
  glGetLightfv : TglGetLightfvProc;
  glGetLightiv : TglGetLightivProc;
  glGetMapdv : TglGetMapdvProc;
  glGetMapfv : TglGetMapfvProc;
  glGetMapiv : TglGetMapivProc;
  glGetMaterialfv : TglGetMaterialfvProc;
  glGetMaterialiv : TglGetMaterialivProc;
  glGetPixelMapfv : TglGetPixelMapfvProc;
  glGetPixelMapuiv : TglGetPixelMapuivProc;
  glGetPixelMapusv : TglGetPixelMapusvProc;
  glGetPointerv : TglGetPointervProc;
  glGetPolygonStipple : TglGetPolygonStippleProc;
  glGetString : TglGetStringProc;
  glGetTexEnvfv : TglGetTexEnvfvProc;
  glGetTexEnviv : TglGetTexEnvivProc;
  glGetTexGendv : TglGetTexGendvProc;
  glGetTexGenfv : TglGetTexGenfvProc;
  glGetTexGeniv : TglGetTexGenivProc;
  glGetTexImage : TglGetTexImageProc;
  glGetTexLevelParameterfv : TglGetTexLevelParameterfvProc;
  glGetTexLevelParameteriv : TglGetTexLevelParameterivProc;
  glGetTexParameterfv : TglGetTexParameterfvProc;
  glGetTexParameteriv : TglGetTexParameterivProc;
  glHint : TglHintProc;
  glIndexMask : TglIndexMaskProc;
  glIndexPointer : TglIndexPointerProc;
  glIndexd : TglIndexdProc;
  glIndexdv : TglIndexdvProc;
  glIndexf : TglIndexfProc;
  glIndexfv : TglIndexfvProc;
  glIndexi : TglIndexiProc;
  glIndexiv : TglIndexivProc;
  glIndexs : TglIndexsProc;
  glIndexsv : TglIndexsvProc;
  glIndexub : TglIndexubProc;
  glIndexubv : TglIndexubvProc;
  glInitNames : TglInitNamesProc;
  glInterleavedArrays : TglInterleavedArraysProc;
  glIsEnabled : TglIsEnabledProc;
  glIsList : TglIsListProc;
  glIsTexture : TglIsTextureProc;
  glLightModelf : TglLightModelfProc;
  glLightModelfv : TglLightModelfvProc;
  glLightModeli : TglLightModeliProc;
  glLightModeliv : TglLightModelivProc;
  glLightf : TglLightfProc;
  glLightfv : TglLightfvProc;
  glLighti : TglLightiProc;
  glLightiv : TglLightivProc;
  glLineStipple : TglLineStippleProc;
  glLineWidth : TglLineWidthProc;
  glListBase : TglListBaseProc;
  glLoadIdentity : TglLoadIdentityProc;
  glLoadMatrixd : TglLoadMatrixdProc;
  glLoadMatrixf : TglLoadMatrixfProc;
  glLoadName : TglLoadNameProc;
  glLogicOp : TglLogicOpProc;
  glMap1d : TglMap1dProc;
  glMap1f : TglMap1fProc;
  glMap2d : TglMap2dProc;
  glMap2f : TglMap2fProc;
  glMapGrid1d : TglMapGrid1dProc;
  glMapGrid1f : TglMapGrid1fProc;
  glMapGrid2d : TglMapGrid2dProc;
  glMapGrid2f : TglMapGrid2fProc;
  glMaterialf : TglMaterialfProc;
  glMaterialfv : TglMaterialfvProc;
  glMateriali : TglMaterialiProc;
  glMaterialiv : TglMaterialivProc;
  glMatrixMode : TglMatrixModeProc;
  glMultMatrixd : TglMultMatrixdProc;
  glMultMatrixf : TglMultMatrixfProc;
  glNewList : TglNewListProc;
  glNormal3b : TglNormal3bProc;
  glNormal3bv : TglNormal3bvProc;
  glNormal3d : TglNormal3dProc;
  glNormal3dv : TglNormal3dvProc;
  glNormal3f : TglNormal3fProc;
  glNormal3fv : TglNormal3fvProc;
  glNormal3i : TglNormal3iProc;
  glNormal3iv : TglNormal3ivProc;
  glNormal3s : TglNormal3sProc;
  glNormal3sv : TglNormal3svProc;
  glNormalPointer : TglNormalPointerProc;
  glOrtho : TglOrthoProc;
  glPassThrough : TglPassThroughProc;
  glPixelMapfv : TglPixelMapfvProc;
  glPixelMapuiv : TglPixelMapuivProc;
  glPixelMapusv : TglPixelMapusvProc;
  glPixelStoref : TglPixelStorefProc;
  glPixelStorei : TglPixelStoreiProc;
  glPixelTransferf : TglPixelTransferfProc;
  glPixelTransferi : TglPixelTransferiProc;
  glPixelZoom : TglPixelZoomProc;
  glPointSize : TglPointSizeProc;
  glPolygonMode : TglPolygonModeProc;
  glPolygonOffset : TglPolygonOffsetProc;
  glPolygonStipple : TglPolygonStippleProc;
  glPopAttrib : TglPopAttribProc;
  glPopClientAttrib : TglPopClientAttribProc;
  glPopMatrix : TglPopMatrixProc;
  glPopName : TglPopNameProc;
  glPrioritizeTextures : TglPrioritizeTexturesProc;
  glPushAttrib : TglPushAttribProc;
  glPushClientAttrib : TglPushClientAttribProc;
  glPushMatrix : TglPushMatrixProc;
  glPushName : TglPushNameProc;
  glRasterPos2d : TglRasterPos2dProc;
  glRasterPos2dv : TglRasterPos2dvProc;
  glRasterPos2f : TglRasterPos2fProc;
  glRasterPos2fv : TglRasterPos2fvProc;
  glRasterPos2i : TglRasterPos2iProc;
  glRasterPos2iv : TglRasterPos2ivProc;
  glRasterPos2s : TglRasterPos2sProc;
  glRasterPos2sv : TglRasterPos2svProc;
  glRasterPos3d : TglRasterPos3dProc;
  glRasterPos3dv : TglRasterPos3dvProc;
  glRasterPos3f : TglRasterPos3fProc;
  glRasterPos3fv : TglRasterPos3fvProc;
  glRasterPos3i : TglRasterPos3iProc;
  glRasterPos3iv : TglRasterPos3ivProc;
  glRasterPos3s : TglRasterPos3sProc;
  glRasterPos3sv : TglRasterPos3svProc;
  glRasterPos4d : TglRasterPos4dProc;
  glRasterPos4dv : TglRasterPos4dvProc;
  glRasterPos4f : TglRasterPos4fProc;
  glRasterPos4fv : TglRasterPos4fvProc;
  glRasterPos4i : TglRasterPos4iProc;
  glRasterPos4iv : TglRasterPos4ivProc;
  glRasterPos4s : TglRasterPos4sProc;
  glRasterPos4sv : TglRasterPos4svProc;
  glReadBuffer : TglReadBufferProc;
  glReadPixels : TglReadPixelsProc;
  glRectd : TglRectdProc;
  glRectdv : TglRectdvProc;
  glRectf : TglRectfProc;
  glRectfv : TglRectfvProc;
  glRecti : TglRectiProc;
  glRectiv : TglRectivProc;
  glRects : TglRectsProc;
  glRectsv : TglRectsvProc;
  glRenderMode : TglRenderModeProc;
  glRotated : TglRotatedProc;
  glRotatef : TglRotatefProc;
  glScaled : TglScaledProc;
  glScalef : TglScalefProc;
  glScissor : TglScissorProc;
  glSelectBuffer : TglSelectBufferProc;
  glShadeModel : TglShadeModelProc;
  glStencilFunc : TglStencilFuncProc;
  glStencilMask : TglStencilMaskProc;
  glStencilOp : TglStencilOpProc;
  glTexCoord1d : TglTexCoord1dProc;
  glTexCoord1dv : TglTexCoord1dvProc;
  glTexCoord1f : TglTexCoord1fProc;
  glTexCoord1fv : TglTexCoord1fvProc;
  glTexCoord1i : TglTexCoord1iProc;
  glTexCoord1iv : TglTexCoord1ivProc;
  glTexCoord1s : TglTexCoord1sProc;
  glTexCoord1sv : TglTexCoord1svProc;
  glTexCoord2d : TglTexCoord2dProc;
  glTexCoord2dv : TglTexCoord2dvProc;
  glTexCoord2f : TglTexCoord2fProc;
  glTexCoord2fv : TglTexCoord2fvProc;
  glTexCoord2i : TglTexCoord2iProc;
  glTexCoord2iv : TglTexCoord2ivProc;
  glTexCoord2s : TglTexCoord2sProc;
  glTexCoord2sv : TglTexCoord2svProc;
  glTexCoord3d : TglTexCoord3dProc;
  glTexCoord3dv : TglTexCoord3dvProc;
  glTexCoord3f : TglTexCoord3fProc;
  glTexCoord3fv : TglTexCoord3fvProc;
  glTexCoord3i : TglTexCoord3iProc;
  glTexCoord3iv : TglTexCoord3ivProc;
  glTexCoord3s : TglTexCoord3sProc;
  glTexCoord3sv : TglTexCoord3svProc;
  glTexCoord4d : TglTexCoord4dProc;
  glTexCoord4dv : TglTexCoord4dvProc;
  glTexCoord4f : TglTexCoord4fProc;
  glTexCoord4fv : TglTexCoord4fvProc;
  glTexCoord4i : TglTexCoord4iProc;
  glTexCoord4iv : TglTexCoord4ivProc;
  glTexCoord4s : TglTexCoord4sProc;
  glTexCoord4sv : TglTexCoord4svProc;
  glTexCoordPointer : TglTexCoordPointerProc;
  glTexEnvf : TglTexEnvfProc;
  glTexEnvfv : TglTexEnvfvProc;
  glTexEnvi : TglTexEnviProc;
  glTexEnviv : TglTexEnvivProc;
  glTexGend : TglTexGendProc;
  glTexGendv : TglTexGendvProc;
  glTexGenf : TglTexGenfProc;
  glTexGenfv : TglTexGenfvProc;
  glTexGeni : TglTexGeniProc;
  glTexGeniv : TglTexGenivProc;
  glTexImage1D : TglTexImage1DProc;
  glTexImage2D : TglTexImage2DProc;
  glTexParameterf : TglTexParameterfProc;
  glTexParameterfv : TglTexParameterfvProc;
  glTexParameteri : TglTexParameteriProc;
  glTexParameteriv : TglTexParameterivProc;
  glTexSubImage1D : TglTexSubImage1DProc;
  glTexSubImage2D : TglTexSubImage2DProc;
  glTranslated : TglTranslatedProc;
  glTranslatef : TglTranslatefProc;
  glVertex2d : TglVertex2dProc;
  glVertex2dv : TglVertex2dvProc;
  glVertex2f : TglVertex2fProc;
  glVertex2fv : TglVertex2fvProc;
  glVertex2i : TglVertex2iProc;
  glVertex2iv : TglVertex2ivProc;
  glVertex2s : TglVertex2sProc;
  glVertex2sv : TglVertex2svProc;
  glVertex3d : TglVertex3dProc;
  glVertex3dv : TglVertex3dvProc;
  glVertex3f : TglVertex3fProc;
  glVertex3fv : TglVertex3fvProc;
  glVertex3i : TglVertex3iProc;
  glVertex3iv : TglVertex3ivProc;
  glVertex3s : TglVertex3sProc;
  glVertex3sv : TglVertex3svProc;
  glVertex4d : TglVertex4dProc;
  glVertex4dv : TglVertex4dvProc;
  glVertex4f : TglVertex4fProc;
  glVertex4fv : TglVertex4fvProc;
  glVertex4i : TglVertex4iProc;
  glVertex4iv : TglVertex4ivProc;
  glVertex4s : TglVertex4sProc;
  glVertex4sv : TglVertex4svProc;
  glVertexPointer : TglVertexPointerProc;
  glViewport : TglViewportProc;
  wglCopyContext : TwglCopyContextProc;
  wglCreateContext : TwglCreateContextProc;
  wglCreateLayerContext : TwglCreateLayerContextProc;
  wglDeleteContext : TwglDeleteContextProc;
  wglGetCurrentContext : TwglGetCurrentContext;
  wglGetCurrentDC : TwglGetCurrentDC;
  wglMakeCurrent : TwglMakeCurrentProc;
  wglShareLists : TwglShareListsProc;
  wglUseFontBitmapsA : TwglUseFontBitmapsAProc;
  wglUseFontBitmapsW : TwglUseFontBitmapsWProc;
  wglUseFontBitmaps : TwglUseFontBitmapsProc;
  wglUseFontOutlinesA : TwglUseFontOutlinesAProc;
  wglUseFontOutlinesW : TwglUseFontOutlinesWProc;
  wglUseFontOutlines : TwglUseFontOutlinesProc;
  wglDescribeLayerPlane : TwglDescribeLayerPlaneProc;
  wglSetLayerPaletteEntries : TwglSetLayerPaletteEntriesProc;
  wglGetLayerPaletteEntries : TwglGetLayerPaletteEntriesProc;
  wglRealizeLayerPalette : TwglRealizeLayerPaletteProc;
  wglSwapLayerBuffers : TwglSwapLayerBuffersProc;
  SwapBuffers : TSwapBuffersProc;
  ChoosePixelFormat : TChoosePixelFormatProc;
  GetPixelFormat : TGetPixelFormatProc;
  SetPixelFormat : TSetPixelFormatProc;
  DescribePixelFormat : TDescribePixelFormatProc;

{!! Unit initialization }

procedure GlInitialize;

procedure GlUninitialize;

procedure GlInitializeFromLibrary (const DllName : string);

implementation

{ Private stuff }

var
  GlHandle : HINST;

procedure InitError (ErrorCode : Integer);
begin
  raise Exception.CreateFmt('Error %d initializing OpenGL: %s', [ErrorCode,
    SysErrorMessage(ErrorCode)]);
end;

function CheckProc (Proc : Pointer) : Boolean;
begin
  if Proc = nil then
    begin
      Result:=False;
      if GetLastError <> ERROR_PROC_NOT_FOUND then
        InitError(GetLastError);
    end
  else
    Result:=True;
end;

procedure GlLoadProcs (Handle : HINST);
begin
  @glAccum:=GetProcAddress(Handle, 'glAccum');
  @glAlphaFunc:=GetProcAddress(Handle, 'glAlphaFunc');
  @glAreTexturesResident:=GetProcAddress(Handle, 'glAreTexturesResident');
  @glArrayElement:=GetProcAddress(Handle, 'glArrayElement');
  @glBegin:=GetProcAddress(Handle, 'glBegin');
  @glBindTexture:=GetProcAddress(Handle, 'glBindTexture');
  @glBitmap:=GetProcAddress(Handle, 'glBitmap');
  @glBlendFunc:=GetProcAddress(Handle, 'glBlendFunc');
  @glCallList:=GetProcAddress(Handle, 'glCallList');
  @glCallLists:=GetProcAddress(Handle, 'glCallLists');
  @glClear:=GetProcAddress(Handle, 'glClear');
  @glClearAccum:=GetProcAddress(Handle, 'glClearAccum');
  @glClearColor:=GetProcAddress(Handle, 'glClearColor');
  @glClearDepth:=GetProcAddress(Handle, 'glClearDepth');
  @glClearIndex:=GetProcAddress(Handle, 'glClearIndex');
  @glClearStencil:=GetProcAddress(Handle, 'glClearStencil');
  @glClipPlane:=GetProcAddress(Handle, 'glClipPlane');
  @glColor3b:=GetProcAddress(Handle, 'glColor3b');
  @glColor3bv:=GetProcAddress(Handle, 'glColor3bv');
  @glColor3d:=GetProcAddress(Handle, 'glColor3d');
  @glColor3dv:=GetProcAddress(Handle, 'glColor3dv');
  @glColor3f:=GetProcAddress(Handle, 'glColor3f');
  @glColor3fv:=GetProcAddress(Handle, 'glColor3fv');
  @glColor3i:=GetProcAddress(Handle, 'glColor3i');
  @glColor3iv:=GetProcAddress(Handle, 'glColor3iv');
  @glColor3s:=GetProcAddress(Handle, 'glColor3s');
  @glColor3sv:=GetProcAddress(Handle, 'glColor3sv');
  @glColor3ub:=GetProcAddress(Handle, 'glColor3ub');
  @glColor3ubv:=GetProcAddress(Handle, 'glColor3ubv');
  @glColor3ui:=GetProcAddress(Handle, 'glColor3ui');
  @glColor3uiv:=GetProcAddress(Handle, 'glColor3uiv');
  @glColor3us:=GetProcAddress(Handle, 'glColor3us');
  @glColor3usv:=GetProcAddress(Handle, 'glColor3usv');
  @glColor4b:=GetProcAddress(Handle, 'glColor4b');
  @glColor4bv:=GetProcAddress(Handle, 'glColor4bv');
  @glColor4d:=GetProcAddress(Handle, 'glColor4d');
  @glColor4dv:=GetProcAddress(Handle, 'glColor4dv');
  @glColor4f:=GetProcAddress(Handle, 'glColor4f');
  @glColor4fv:=GetProcAddress(Handle, 'glColor4fv');
  @glColor4i:=GetProcAddress(Handle, 'glColor4i');
  @glColor4iv:=GetProcAddress(Handle, 'glColor4iv');
  @glColor4s:=GetProcAddress(Handle, 'glColor4s');
  @glColor4sv:=GetProcAddress(Handle, 'glColor4sv');
  @glColor4ub:=GetProcAddress(Handle, 'glColor4ub');
  @glColor4ubv:=GetProcAddress(Handle, 'glColor4ubv');
  @glColor4ui:=GetProcAddress(Handle, 'glColor4ui');
  @glColor4uiv:=GetProcAddress(Handle, 'glColor4uiv');
  @glColor4us:=GetProcAddress(Handle, 'glColor4us');
  @glColor4usv:=GetProcAddress(Handle, 'glColor4usv');
  @glColorMask:=GetProcAddress(Handle, 'glColorMask');
  @glColorMaterial:=GetProcAddress(Handle, 'glColorMaterial');
  @glColorPointer:=GetProcAddress(Handle, 'glColorPointer');
  @glCopyPixels:=GetProcAddress(Handle, 'glCopyPixels');
  @glCopyTexImage1D:=GetProcAddress(Handle, 'glCopyTexImage1D');
  @glCopyTexImage2D:=GetProcAddress(Handle, 'glCopyTexImage2D');
  @glCopyTexSubImage1D:=GetProcAddress(Handle, 'glCopyTexSubImage1D');
  @glCopyTexSubImage2D:=GetProcAddress(Handle, 'glCopyTexSubImage2D');
  @glCullFace:=GetProcAddress(Handle, 'glCullFace');
  @glDeleteLists:=GetProcAddress(Handle, 'glDeleteLists');
  @glDeleteTextures:=GetProcAddress(Handle, 'glDeleteTextures');
  @glDepthFunc:=GetProcAddress(Handle, 'glDepthFunc');
  @glDepthMask:=GetProcAddress(Handle, 'glDepthMask');
  @glDepthRange:=GetProcAddress(Handle, 'glDepthRange');
  @glDisable:=GetProcAddress(Handle, 'glDisable');
  @glDisableClientState:=GetProcAddress(Handle, 'glDisableClientState');
  @glDrawArrays:=GetProcAddress(Handle, 'glDrawArrays');
  @glDrawBuffer:=GetProcAddress(Handle, 'glDrawBuffer');
  @glDrawElements:=GetProcAddress(Handle, 'glDrawElements');
  @glDrawPixels:=GetProcAddress(Handle, 'glDrawPixels');
  @glEdgeFlag:=GetProcAddress(Handle, 'glEdgeFlag');
  @glEdgeFlagPointer:=GetProcAddress(Handle, 'glEdgeFlagPointer');
  @glEdgeFlagv:=GetProcAddress(Handle, 'glEdgeFlagv');
  @glEnable:=GetProcAddress(Handle, 'glEnable');
  @glEnableClientState:=GetProcAddress(Handle, 'glEnableClientState');
  @glEnd:=GetProcAddress(Handle, 'glEnd');
  @glEndList:=GetProcAddress(Handle, 'glEndList');
  @glEvalCoord1d:=GetProcAddress(Handle, 'glEvalCoord1d');
  @glEvalCoord1dv:=GetProcAddress(Handle, 'glEvalCoord1dv');
  @glEvalCoord1f:=GetProcAddress(Handle, 'glEvalCoord1f');
  @glEvalCoord1fv:=GetProcAddress(Handle, 'glEvalCoord1fv');
  @glEvalCoord2d:=GetProcAddress(Handle, 'glEvalCoord2d');
  @glEvalCoord2dv:=GetProcAddress(Handle, 'glEvalCoord2dv');
  @glEvalCoord2f:=GetProcAddress(Handle, 'glEvalCoord2f');
  @glEvalCoord2fv:=GetProcAddress(Handle, 'glEvalCoord2fv');
  @glEvalMesh1:=GetProcAddress(Handle, 'glEvalMesh1');
  @glEvalMesh2:=GetProcAddress(Handle, 'glEvalMesh2');
  @glEvalPoint1:=GetProcAddress(Handle, 'glEvalPoint1');
  @glEvalPoint2:=GetProcAddress(Handle, 'glEvalPoint2');
  @glFeedbackBuffer:=GetProcAddress(Handle, 'glFeedbackBuffer');
  @glFinish:=GetProcAddress(Handle, 'glFinish');
  @glFlush:=GetProcAddress(Handle, 'glFlush');
  @glFogf:=GetProcAddress(Handle, 'glFogf');
  @glFogfv:=GetProcAddress(Handle, 'glFogfv');
  @glFogi:=GetProcAddress(Handle, 'glFogi');
  @glFogiv:=GetProcAddress(Handle, 'glFogiv');
  @glFrontFace:=GetProcAddress(Handle, 'glFrontFace');
  @glFrustum:=GetProcAddress(Handle, 'glFrustum');
  @glGenLists:=GetProcAddress(Handle, 'glGenLists');
  @glGenTextures:=GetProcAddress(Handle, 'glGenTextures');
  @glGetBooleanv:=GetProcAddress(Handle, 'glGetBooleanv');
  @glGetClipPlane:=GetProcAddress(Handle, 'glGetClipPlane');
  @glGetDoublev:=GetProcAddress(Handle, 'glGetDoublev');
  @glGetError:=GetProcAddress(Handle, 'glGetError');
  @glGetFloatv:=GetProcAddress(Handle, 'glGetFloatv');
  @glGetIntegerv:=GetProcAddress(Handle, 'glGetIntegerv');
  @glGetLightfv:=GetProcAddress(Handle, 'glGetLightfv');
  @glGetLightiv:=GetProcAddress(Handle, 'glGetLightiv');
  @glGetMapdv:=GetProcAddress(Handle, 'glGetMapdv');
  @glGetMapfv:=GetProcAddress(Handle, 'glGetMapfv');
  @glGetMapiv:=GetProcAddress(Handle, 'glGetMapiv');
  @glGetMaterialfv:=GetProcAddress(Handle, 'glGetMaterialfv');
  @glGetMaterialiv:=GetProcAddress(Handle, 'glGetMaterialiv');
  @glGetPixelMapfv:=GetProcAddress(Handle, 'glGetPixelMapfv');
  @glGetPixelMapuiv:=GetProcAddress(Handle, 'glGetPixelMapuiv');
  @glGetPixelMapusv:=GetProcAddress(Handle, 'glGetPixelMapusv');
  @glGetPointerv:=GetProcAddress(Handle, 'glGetPointerv');
  @glGetPolygonStipple:=GetProcAddress(Handle, 'glGetPolygonStipple');
  @glGetString:=GetProcAddress(Handle, 'glGetString');
  @glGetTexEnvfv:=GetProcAddress(Handle, 'glGetTexEnvfv');
  @glGetTexEnviv:=GetProcAddress(Handle, 'glGetTexEnviv');
  @glGetTexGendv:=GetProcAddress(Handle, 'glGetTexGendv');
  @glGetTexGenfv:=GetProcAddress(Handle, 'glGetTexGenfv');
  @glGetTexGeniv:=GetProcAddress(Handle, 'glGetTexGeniv');
  @glGetTexImage:=GetProcAddress(Handle, 'glGetTexImage');
  @glGetTexLevelParameterfv:=GetProcAddress(Handle,
    'glGetTexLevelParameterfv');
  @glGetTexLevelParameteriv:=GetProcAddress(Handle,
    'glGetTexLevelParameteriv');
  @glGetTexParameterfv:=GetProcAddress(Handle, 'glGetTexParameterfv');
  @glGetTexParameteriv:=GetProcAddress(Handle, 'glGetTexParameteriv');
  @glHint:=GetProcAddress(Handle, 'glHint');
  @glIndexMask:=GetProcAddress(Handle, 'glIndexMask');
  @glIndexPointer:=GetProcAddress(Handle, 'glIndexPointer');
  @glIndexd:=GetProcAddress(Handle, 'glIndexd');
  @glIndexdv:=GetProcAddress(Handle, 'glIndexdv');
  @glIndexf:=GetProcAddress(Handle, 'glIndexf');
  @glIndexfv:=GetProcAddress(Handle, 'glIndexfv');
  @glIndexi:=GetProcAddress(Handle, 'glIndexi');
  @glIndexiv:=GetProcAddress(Handle, 'glIndexiv');
  @glIndexs:=GetProcAddress(Handle, 'glIndexs');
  @glIndexsv:=GetProcAddress(Handle, 'glIndexsv');
  @glIndexub:=GetProcAddress(Handle, 'glIndexub');
  @glIndexubv:=GetProcAddress(Handle, 'glIndexubv');
  @glInitNames:=GetProcAddress(Handle, 'glInitNames');
  @glInterleavedArrays:=GetProcAddress(Handle, 'glInterleavedArrays');
  @glIsEnabled:=GetProcAddress(Handle, 'glIsEnabled');
  @glIsList:=GetProcAddress(Handle, 'glIsList');
  @glIsTexture:=GetProcAddress(Handle, 'glIsTexture');
  @glLightModelf:=GetProcAddress(Handle, 'glLightModelf');
  @glLightModelfv:=GetProcAddress(Handle, 'glLightModelfv');
  @glLightModeli:=GetProcAddress(Handle, 'glLightModeli');
  @glLightModeliv:=GetProcAddress(Handle, 'glLightModeliv');
  @glLightf:=GetProcAddress(Handle, 'glLightf');
  @glLightfv:=GetProcAddress(Handle, 'glLightfv');
  @glLighti:=GetProcAddress(Handle, 'glLighti');
  @glLightiv:=GetProcAddress(Handle, 'glLightiv');
  @glLineStipple:=GetProcAddress(Handle, 'glLineStipple');
  @glLineWidth:=GetProcAddress(Handle, 'glLineWidth');
  @glListBase:=GetProcAddress(Handle, 'glListBase');
  @glLoadIdentity:=GetProcAddress(Handle, 'glLoadIdentity');
  @glLoadMatrixd:=GetProcAddress(Handle, 'glLoadMatrixd');
  @glLoadMatrixf:=GetProcAddress(Handle, 'glLoadMatrixf');
  @glLoadName:=GetProcAddress(Handle, 'glLoadName');
  @glLogicOp:=GetProcAddress(Handle, 'glLogicOp');
  @glMap1d:=GetProcAddress(Handle, 'glMap1d');
  @glMap1f:=GetProcAddress(Handle, 'glMap1f');
  @glMap2d:=GetProcAddress(Handle, 'glMap2d');
  @glMap2f:=GetProcAddress(Handle, 'glMap2f');
  @glMapGrid1d:=GetProcAddress(Handle, 'glMapGrid1d');
  @glMapGrid1f:=GetProcAddress(Handle, 'glMapGrid1f');
  @glMapGrid2d:=GetProcAddress(Handle, 'glMapGrid2d');
  @glMapGrid2f:=GetProcAddress(Handle, 'glMapGrid2f');
  @glMaterialf:=GetProcAddress(Handle, 'glMaterialf');
  @glMaterialfv:=GetProcAddress(Handle, 'glMaterialfv');
  @glMateriali:=GetProcAddress(Handle, 'glMateriali');
  @glMaterialiv:=GetProcAddress(Handle, 'glMaterialiv');
  @glMatrixMode:=GetProcAddress(Handle, 'glMatrixMode');
  @glMultMatrixd:=GetProcAddress(Handle, 'glMultMatrixd');
  @glMultMatrixf:=GetProcAddress(Handle, 'glMultMatrixf');
  @glNewList:=GetProcAddress(Handle, 'glNewList');
  @glNormal3b:=GetProcAddress(Handle, 'glNormal3b');
  @glNormal3bv:=GetProcAddress(Handle, 'glNormal3bv');
  @glNormal3d:=GetProcAddress(Handle, 'glNormal3d');
  @glNormal3dv:=GetProcAddress(Handle, 'glNormal3dv');
  @glNormal3f:=GetProcAddress(Handle, 'glNormal3f');
  @glNormal3fv:=GetProcAddress(Handle, 'glNormal3fv');
  @glNormal3i:=GetProcAddress(Handle, 'glNormal3i');
  @glNormal3iv:=GetProcAddress(Handle, 'glNormal3iv');
  @glNormal3s:=GetProcAddress(Handle, 'glNormal3s');
  @glNormal3sv:=GetProcAddress(Handle, 'glNormal3sv');
  @glNormalPointer:=GetProcAddress(Handle, 'glNormalPointer');
  @glOrtho:=GetProcAddress(Handle, 'glOrtho');
  @glPassThrough:=GetProcAddress(Handle, 'glPassThrough');
  @glPixelMapfv:=GetProcAddress(Handle, 'glPixelMapfv');
  @glPixelMapuiv:=GetProcAddress(Handle, 'glPixelMapuiv');
  @glPixelMapusv:=GetProcAddress(Handle, 'glPixelMapusv');
  @glPixelStoref:=GetProcAddress(Handle, 'glPixelStoref');
  @glPixelStorei:=GetProcAddress(Handle, 'glPixelStorei');
  @glPixelTransferf:=GetProcAddress(Handle, 'glPixelTransferf');
  @glPixelTransferi:=GetProcAddress(Handle, 'glPixelTransferi');
  @glPixelZoom:=GetProcAddress(Handle, 'glPixelZoom');
  @glPointSize:=GetProcAddress(Handle, 'glPointSize');
  @glPolygonMode:=GetProcAddress(Handle, 'glPolygonMode');
  @glPolygonOffset:=GetProcAddress(Handle, 'glPolygonOffset');
  @glPolygonStipple:=GetProcAddress(Handle, 'glPolygonStipple');
  @glPopAttrib:=GetProcAddress(Handle, 'glPopAttrib');
  @glPopClientAttrib:=GetProcAddress(Handle, 'glPopClientAttrib');
  @glPopMatrix:=GetProcAddress(Handle, 'glPopMatrix');
  @glPopName:=GetProcAddress(Handle, 'glPopName');
  @glPrioritizeTextures:=GetProcAddress(Handle, 'glPrioritizeTextures');
  @glPushAttrib:=GetProcAddress(Handle, 'glPushAttrib');
  @glPushClientAttrib:=GetProcAddress(Handle, 'glPushClientAttrib');
  @glPushMatrix:=GetProcAddress(Handle, 'glPushMatrix');
  @glPushName:=GetProcAddress(Handle, 'glPushName');
  @glRasterPos2d:=GetProcAddress(Handle, 'glRasterPos2d');
  @glRasterPos2dv:=GetProcAddress(Handle, 'glRasterPos2dv');
  @glRasterPos2f:=GetProcAddress(Handle, 'glRasterPos2f');
  @glRasterPos2fv:=GetProcAddress(Handle, 'glRasterPos2fv');
  @glRasterPos2i:=GetProcAddress(Handle, 'glRasterPos2i');
  @glRasterPos2iv:=GetProcAddress(Handle, 'glRasterPos2iv');
  @glRasterPos2s:=GetProcAddress(Handle, 'glRasterPos2s');
  @glRasterPos2sv:=GetProcAddress(Handle, 'glRasterPos2sv');
  @glRasterPos3d:=GetProcAddress(Handle, 'glRasterPos3d');
  @glRasterPos3dv:=GetProcAddress(Handle, 'glRasterPos3dv');
  @glRasterPos3f:=GetProcAddress(Handle, 'glRasterPos3f');
  @glRasterPos3fv:=GetProcAddress(Handle, 'glRasterPos3fv');
  @glRasterPos3i:=GetProcAddress(Handle, 'glRasterPos3i');
  @glRasterPos3iv:=GetProcAddress(Handle, 'glRasterPos3iv');
  @glRasterPos3s:=GetProcAddress(Handle, 'glRasterPos3s');
  @glRasterPos3sv:=GetProcAddress(Handle, 'glRasterPos3sv');
  @glRasterPos4d:=GetProcAddress(Handle, 'glRasterPos4d');
  @glRasterPos4dv:=GetProcAddress(Handle, 'glRasterPos4dv');
  @glRasterPos4f:=GetProcAddress(Handle, 'glRasterPos4f');
  @glRasterPos4fv:=GetProcAddress(Handle, 'glRasterPos4fv');
  @glRasterPos4i:=GetProcAddress(Handle, 'glRasterPos4i');
  @glRasterPos4iv:=GetProcAddress(Handle, 'glRasterPos4iv');
  @glRasterPos4s:=GetProcAddress(Handle, 'glRasterPos4s');
  @glRasterPos4sv:=GetProcAddress(Handle, 'glRasterPos4sv');
  @glReadBuffer:=GetProcAddress(Handle, 'glReadBuffer');
  @glReadPixels:=GetProcAddress(Handle, 'glReadPixels');
  @glRectd:=GetProcAddress(Handle, 'glRectd');
  @glRectdv:=GetProcAddress(Handle, 'glRectdv');
  @glRectf:=GetProcAddress(Handle, 'glRectf');
  @glRectfv:=GetProcAddress(Handle, 'glRectfv');
  @glRecti:=GetProcAddress(Handle, 'glRecti');
  @glRectiv:=GetProcAddress(Handle, 'glRectiv');
  @glRects:=GetProcAddress(Handle, 'glRects');
  @glRectsv:=GetProcAddress(Handle, 'glRectsv');
  @glRenderMode:=GetProcAddress(Handle, 'glRenderMode');
  @glRotated:=GetProcAddress(Handle, 'glRotated');
  @glRotatef:=GetProcAddress(Handle, 'glRotatef');
  @glScaled:=GetProcAddress(Handle, 'glScaled');
  @glScalef:=GetProcAddress(Handle, 'glScalef');
  @glScissor:=GetProcAddress(Handle, 'glScissor');
  @glSelectBuffer:=GetProcAddress(Handle, 'glSelectBuffer');
  @glShadeModel:=GetProcAddress(Handle, 'glShadeModel');
  @glStencilFunc:=GetProcAddress(Handle, 'glStencilFunc');
  @glStencilMask:=GetProcAddress(Handle, 'glStencilMask');
  @glStencilOp:=GetProcAddress(Handle, 'glStencilOp');
  @glTexCoord1d:=GetProcAddress(Handle, 'glTexCoord1d');
  @glTexCoord1dv:=GetProcAddress(Handle, 'glTexCoord1dv');
  @glTexCoord1f:=GetProcAddress(Handle, 'glTexCoord1f');
  @glTexCoord1fv:=GetProcAddress(Handle, 'glTexCoord1fv');
  @glTexCoord1i:=GetProcAddress(Handle, 'glTexCoord1i');
  @glTexCoord1iv:=GetProcAddress(Handle, 'glTexCoord1iv');
  @glTexCoord1s:=GetProcAddress(Handle, 'glTexCoord1s');
  @glTexCoord1sv:=GetProcAddress(Handle, 'glTexCoord1sv');
  @glTexCoord2d:=GetProcAddress(Handle, 'glTexCoord2d');
  @glTexCoord2dv:=GetProcAddress(Handle, 'glTexCoord2dv');
  @glTexCoord2f:=GetProcAddress(Handle, 'glTexCoord2f');
  @glTexCoord2fv:=GetProcAddress(Handle, 'glTexCoord2fv');
  @glTexCoord2i:=GetProcAddress(Handle, 'glTexCoord2i');
  @glTexCoord2iv:=GetProcAddress(Handle, 'glTexCoord2iv');
  @glTexCoord2s:=GetProcAddress(Handle, 'glTexCoord2s');
  @glTexCoord2sv:=GetProcAddress(Handle, 'glTexCoord2sv');
  @glTexCoord3d:=GetProcAddress(Handle, 'glTexCoord3d');
  @glTexCoord3dv:=GetProcAddress(Handle, 'glTexCoord3dv');
  @glTexCoord3f:=GetProcAddress(Handle, 'glTexCoord3f');
  @glTexCoord3fv:=GetProcAddress(Handle, 'glTexCoord3fv');
  @glTexCoord3i:=GetProcAddress(Handle, 'glTexCoord3i');
  @glTexCoord3iv:=GetProcAddress(Handle, 'glTexCoord3iv');
  @glTexCoord3s:=GetProcAddress(Handle, 'glTexCoord3s');
  @glTexCoord3sv:=GetProcAddress(Handle, 'glTexCoord3sv');
  @glTexCoord4d:=GetProcAddress(Handle, 'glTexCoord4d');
  @glTexCoord4dv:=GetProcAddress(Handle, 'glTexCoord4dv');
  @glTexCoord4f:=GetProcAddress(Handle, 'glTexCoord4f');
  @glTexCoord4fv:=GetProcAddress(Handle, 'glTexCoord4fv');
  @glTexCoord4i:=GetProcAddress(Handle, 'glTexCoord4i');
  @glTexCoord4iv:=GetProcAddress(Handle, 'glTexCoord4iv');
  @glTexCoord4s:=GetProcAddress(Handle, 'glTexCoord4s');
  @glTexCoord4sv:=GetProcAddress(Handle, 'glTexCoord4sv');
  @glTexCoordPointer:=GetProcAddress(Handle, 'glTexCoordPointer');
  @glTexEnvf:=GetProcAddress(Handle, 'glTexEnvf');
  @glTexEnvfv:=GetProcAddress(Handle, 'glTexEnvfv');
  @glTexEnvi:=GetProcAddress(Handle, 'glTexEnvi');
  @glTexEnviv:=GetProcAddress(Handle, 'glTexEnviv');
  @glTexGend:=GetProcAddress(Handle, 'glTexGend');
  @glTexGendv:=GetProcAddress(Handle, 'glTexGendv');
  @glTexGenf:=GetProcAddress(Handle, 'glTexGenf');
  @glTexGenfv:=GetProcAddress(Handle, 'glTexGenfv');
  @glTexGeni:=GetProcAddress(Handle, 'glTexGeni');
  @glTexGeniv:=GetProcAddress(Handle, 'glTexGeniv');
  @glTexImage1D:=GetProcAddress(Handle, 'glTexImage1D');
  @glTexImage2D:=GetProcAddress(Handle, 'glTexImage2D');
  @glTexParameterf:=GetProcAddress(Handle, 'glTexParameterf');
  @glTexParameterfv:=GetProcAddress(Handle, 'glTexParameterfv');
  @glTexParameteri:=GetProcAddress(Handle, 'glTexParameteri');
  @glTexParameteriv:=GetProcAddress(Handle, 'glTexParameteriv');
  @glTexSubImage1D:=GetProcAddress(Handle, 'glTexSubImage1D');
  @glTexSubImage2D:=GetProcAddress(Handle, 'glTexSubImage2D');
  @glTranslated:=GetProcAddress(Handle, 'glTranslated');
  @glTranslatef:=GetProcAddress(Handle, 'glTranslatef');
  @glVertex2d:=GetProcAddress(Handle, 'glVertex2d');
  @glVertex2dv:=GetProcAddress(Handle, 'glVertex2dv');
  @glVertex2f:=GetProcAddress(Handle, 'glVertex2f');
  @glVertex2fv:=GetProcAddress(Handle, 'glVertex2fv');
  @glVertex2i:=GetProcAddress(Handle, 'glVertex2i');
  @glVertex2iv:=GetProcAddress(Handle, 'glVertex2iv');
  @glVertex2s:=GetProcAddress(Handle, 'glVertex2s');
  @glVertex2sv:=GetProcAddress(Handle, 'glVertex2sv');
  @glVertex3d:=GetProcAddress(Handle, 'glVertex3d');
  @glVertex3dv:=GetProcAddress(Handle, 'glVertex3dv');
  @glVertex3f:=GetProcAddress(Handle, 'glVertex3f');
  @glVertex3fv:=GetProcAddress(Handle, 'glVertex3fv');
  @glVertex3i:=GetProcAddress(Handle, 'glVertex3i');
  @glVertex3iv:=GetProcAddress(Handle, 'glVertex3iv');
  @glVertex3s:=GetProcAddress(Handle, 'glVertex3s');
  @glVertex3sv:=GetProcAddress(Handle, 'glVertex3sv');
  @glVertex4d:=GetProcAddress(Handle, 'glVertex4d');
  @glVertex4dv:=GetProcAddress(Handle, 'glVertex4dv');
  @glVertex4f:=GetProcAddress(Handle, 'glVertex4f');
  @glVertex4fv:=GetProcAddress(Handle, 'glVertex4fv');
  @glVertex4i:=GetProcAddress(Handle, 'glVertex4i');
  @glVertex4iv:=GetProcAddress(Handle, 'glVertex4iv');
  @glVertex4s:=GetProcAddress(Handle, 'glVertex4s');
  @glVertex4sv:=GetProcAddress(Handle, 'glVertex4sv');
  @glVertexPointer:=GetProcAddress(Handle, 'glVertexPointer');
  @glViewport:=GetProcAddress(Handle, 'glViewport');
  @wglCopyContext:=GetProcAddress(Handle, 'wglCopyContext');
  @wglCreateContext:=GetProcAddress(Handle, 'wglCreateContext');
  @wglCreateLayerContext:=GetProcAddress(Handle, 'wglCreateLayerContext');
  @wglDeleteContext:=GetProcAddress(Handle, 'wglDeleteContext');
  @wglGetCurrentContext:=GetProcAddress(Handle, 'wglGetCurrentContext');
  @wglGetCurrentDC:=GetProcAddress(Handle, 'wglGetCurrentDC');
  @wglMakeCurrent:=GetProcAddress(Handle, 'wglMakeCurrent');
  @wglShareLists:=GetProcAddress(Handle, 'wglShareLists');
  @wglUseFontBitmapsA:=GetProcAddress(Handle, 'wglUseFontBitmapsA');
  @wglUseFontBitmapsW:=GetProcAddress(Handle, 'wglUseFontBitmapsW');
  @wglUseFontBitmaps:=GetProcAddress(Handle, 'wglUseFontBitmaps');
  @wglUseFontOutlinesA:=GetProcAddress(Handle, 'wglUseFontOutlinesA');
  @wglUseFontOutlinesW:=GetProcAddress(Handle, 'wglUseFontOutlinesW');
  @wglUseFontOutlines:=GetProcAddress(Handle, 'wglUseFontOutlines');
  @wglDescribeLayerPlane:=GetProcAddress(Handle, 'wglDescribeLayerPlane');
  @wglSetLayerPaletteEntries:=GetProcAddress(Handle, 'wglSetLayerPaletteEntries');
  @wglGetLayerPaletteEntries:=GetProcAddress(Handle, 'wglGetLayerPaletteEntries');
  @wglRealizeLayerPalette:=GetProcAddress(Handle, 'wglRealizeLayerPalette');
  @wglSwapLayerBuffers:=GetProcAddress(Handle, 'wglSwapLayerBuffers');

  @SwapBuffers:=GetProcAddress(Handle, 'SwapBuffers');
  if not CheckProc(@SwapBuffers) then
    SwapBuffers:=@Windows.SwapBuffers;

  @ChoosePixelFormat:=GetProcAddress(Handle, 'ChoosePixelFormat');
  if not CheckProc(@ChoosePixelFormat) then
    ChoosePixelFormat:=@Windows.ChoosePixelFormat;

  @GetPixelFormat:=GetProcAddress(Handle, 'GetPixelFormat');
  if not CheckProc(@GetPixelFormat) then
    GetPixelFormat:=@Windows.GetPixelFormat;

  @SetPixelFormat:=GetProcAddress(Handle, 'SetPixelFormat');
  if not CheckProc(@SetPixelFormat) then
    SetPixelFormat:=@Windows.SetPixelFormat;

  @DescribePixelFormat:=GetProcAddress(Handle, 'DescribePixelFormat');
  if not CheckProc(@DescribePixelFormat) then
    DescribePixelFormat:=@Windows.DescribePixelFormat;
end;

{ Functions }

procedure GlInitialize;
var
  Handle : HINST;
begin
  GlUninitialize;
  Handle:=LoadLibrary('opengl.dll');
  if Handle = 0 then
    begin
      Handle:=LoadLibrary('opengl32.dll');
      if Handle = 0 then
        InitError(GetLastError);
    end;
  try
    GlLoadProcs(Handle);
  except
    FreeLibrary(Handle);
    raise;
  end;
  GlHandle:=Handle;
end;

procedure GlUninitialize;
begin
  if GlHandle <> 0 then
    begin
      FreeLibrary(GlHandle);
      GlHandle:=0;
    end;
end;

procedure GlInitializeFromLibrary (const DllName : string);
var
  Handle : HINST;
begin
  GlUninitialize;
  Handle:=LoadLibrary(PChar(DllName));
  if Handle = 0 then
    InitError(GetLastError);
  try
    GlLoadProcs(Handle);
  except
    FreeLibrary(Handle);
    raise;
  end;
  GlHandle:=Handle;
end;

{ Initialization }

initialization
  begin
  end;

finalization
  begin
    GlUninitialize;
  end;

end.

